<?php
/**
 * @singleton
 * Events page
 */
class AssoFacileEvents {
  private static $instance = NULL;

  /**
   * get static singleton instance
   */
  public static function get_instance() {
    if (!AssoFacileEvents::$instance instanceof self) {
      AssoFacileEvents::$instance = new self();
    }

    return AssoFacileEvents::$instance;
  }

  /**
   * private constructor to create a new instance
   */
  private function __construct() {
    add_action('init', array($this, 'bootstrap'), 0);
  }

  /**
   * adds a new shortcode reserved for reserved area
   */
  public function bootstrap() {
    add_shortcode('assofacile_calendario', array($this, 'add_events_html'));
  }

  /**
   * returns html of reserved area
   */
  public function add_events_html() {
    ob_start();
    /**
     * include html
     */

    if (is_page())
      include(plugin_dir_path( __FILE__ ) . 'pages/events.php');
    return ob_get_clean();
  }

  /**
   * register calendar dependencies
   */
  public function register_calendar_deps() {
  }

  /**
   * enqueue calendar dependencies
   */
  public function enqueue_calendar_deps() {
  }
}

AssoFacileEvents::get_instance();

?>