<?php

/**
 */
class AssoFacileInit {
  public function __construct() {
    add_action('plugins_loaded', array($this, 'loaded'), 100);
    add_action('init', array($this, 'init'), 100);
    add_action('wp_enqueue_scripts', array($this, 'enqueue'), 100);
  }

  function loaded() {
    // load text domain for translations
    load_plugin_textdomain('assofacile', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
  }

  function init() {
    /**
     * force include jQuery
     */
    if (!wp_script_is('jquery')) {
      wp_deregister_script('jquery');
      wp_register_script('jquery', plugins_url('js/jquery-3.5.1.min.js', __FILE__));
    }

    // register internal scripts
    wp_register_script('controlFactory', plugins_url('js/control-factory.js', __FILE__), array('jquery'));
    wp_register_script('assofacileCommon', plugins_url('js/assofacile-common.js', __FILE__), array('jquery'));

    /**
     *  include bootstrap
     */
    if (!wp_script_is('bootstrap')) {
      wp_register_script('bootstrap', plugins_url('js/bootstrap.min.js', __FILE__), array('jquery'));
    }

    // register bootstrap css
    wp_register_style('bootstrap-iso', plugins_url('css/bootstrap-iso.css', __FILE__));
    wp_register_style('bootstrap-theme', plugins_url('css/bootstrap-theme.css', __FILE__));
    wp_register_style('assofacile', plugins_url('css/assofacile.css', __FILE__));

    /**
     * register fontawesome
     */
    wp_register_style("fontawesome", plugins_url('fontawesome/css/all.min.css', __FILE__));

    /**
     * add evo_calendar css
     */
    wp_register_style("evo_calendar_core", plugins_url('evo-calendar/css/evo-calendar.min.css', __FILE__ ));
    // wp_register_style("evo_calendar_theme", plugins_url("evo-calendar/css/$THEME.min.css", __FILE__ ), array("evo_calendar_core"));

    /**
     * add evo_calendar js
     */
    wp_register_script("evo_calendar_js", plugins_url('evo-calendar/js/evo-calendar.js', __FILE__ ), array("jquery"));
   // wp_register_script("calendario", plugins_url('evo-calendar/js/calendario.js', __FILE__ ));
  }

  function enqueue() {
    // enquue bootstrap
    wp_enqueue_style('bootstrap-iso');
    wp_enqueue_style('bootstrap-theme');
    wp_enqueue_style('assofacile');

    /**
     * add fontawesome
     */
    wp_enqueue_style('fontawesome');

    /**
     * force include jQuery
     */
    wp_enqueue_script('jquery');

    /**
     * force include jQuery
     */
    if (!wp_script_is('bootstrap')) {
      wp_enqueue_script('bootstrap');
    }

    /**
     * enqueue internal scripts
     */
    wp_enqueue_script("controlFactory");
    wp_enqueue_script("assofacileCommon");
    wp_enqueue_script("calendario");

    /**
     * add evo_calendar css
     */
    wp_enqueue_style("evo_calendar_core");
    // wp_enqueue_style("evo_calendar_theme");

    /**
     * add evo_calendar js
     */
    wp_enqueue_script("evo_calendar_js");
  }
}

new AssoFacileInit();

?>