<?php

class AssoFacileRules
{
  private static $instance = NULL;
  private static $allowed_attachemnt_types = array();
  private static $api_endpoints = array();

  private function __construct()
  {
    $this->set_attachemnt_types();
    $this->set_api_endpoints();
  }

  public static function get_instance()
  {
    if (!AssoFacileRules::$instance) {
      AssoFacileRules::$instance = new AssoFacileRules();
    }

    return AssoFacileRules::$instance;
  }

  private function set_attachemnt_types()
  {
    self::$allowed_attachemnt_types = array(
      "application/pdf",
      "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
      "text/plain",
      "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
      "application/msword",
      "application/vnd.ms-excel",
      "image/*",
    );
  }

  private function set_api_endpoints()
  {
    self::$api_endpoints = array(
      "base" => "https://www.assofacile.it/",
      "register-form" => "login/wp_form_iscrizione.php",
      "login" => "login/wp_login.php",
      "profile" => "login/wp_profilo.php",
      "updateProfilePicture" => "login/wp_invio_img.php",
      "calendar" => "login/wp_calendario.php",
      "event" => "login/wp_evento.php",
      "receipts" => "login/wp_quote.php",
      "receipt" => "login//wp_ricevute.php",
      "docs" => "login/wp_docs.php",
      "doc" => "login/wp_moduli.php",
      "upload" => "login/wp_invio_moduli.php",
      "msgs-list" => "login/wp_direttivo.php",
      "new-msg" => "login/wp_invio_com_direttivo.php",
      "thread-msgs" => "login/wp_com_direttivo.php",
      "msg-attachment" => "login/wp_allegato_direttivo.php",
      "register" => "login/wp_iscrizione.php",
      "tutelati" =>"login/wp_tutelati.php",
      "login_tut"=>"login/wp_login_tutelati.php",
    );
  }

  public function get_attachement_types()
  {
    return self::$allowed_attachemnt_types;
  }

  public function get_attachement_types_for()
  {
    $types = "";

    foreach (self::$allowed_attachemnt_types as $type) {
      $types .= "$type,";
    }

    return $types;
  }

  public function get_api_endpoints()
  {
    return self::$api_endpoints;
  }

  public function get_api_baseurl()
  {
    return self::$api_endpoints["base"];
  }

  public function get_api_endpoints_for($key)
  {
    return self::$api_endpoints["base"] . self::$api_endpoints[$key];
  }
}
