<?php
include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');

global $post;
$link = get_permalink($post->ID, false);
$rules = AssoFacileRules::get_instance();
?>

<div id="assofacile_sct">
  <!-- <h1 style="text-align: center">Events</h1> -->

  <div class="alignfull">
    <input type="hidden" name="retrievedToken" id="retrievedToken" value="<?php echo $_COOKIE['assofacile_api_token']; ?>">
    <input type="hidden" name="idasso" id="idasso" value="<?php echo get_option('assofacile_assoc_id'); ?>">


    <div id="events_errorContainer">
      <div id="events_error"></div>
    </div>

    <div class="progress" id="events_waitFor" style="display: none; width: 100%; position: relative;">
      <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 50%; text-align: center; position: relative; margin: auto;">
        <span><?php _e("Loading", "assofacile"); ?>...</span>
      </div>
    </div>

    <div id="events_events"></div>

    <!-- The modal -->
    <div id="modal-overlay" style="display: none;">
      <div class="assofacile_event_modal" id="eventModal" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
          <div class="modal-content">
            <div class="modal-header" style="width: 100%">
              <button type="button" class="close modalClose" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>

              <h4 class="modal-title flex-fill" id="modalTitle" style="max-width: 90%;"></h4>
              <i class="fas fa-times" id="modalClose" class="modalClose"></i>
            </div>

            <div class="modal-body" id="modalBody">
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<script>
  const today = new Date();

  const dummyEvents = [];


  jQuery(document).ready(function($) {
    /**
     * event cache(downloaded events)
     */
    eventCache = [];

    const errorContainer = $("#events_errorContainer").hide();
    const error = $("#events_error");

    const calendar = $("#events_events")
      .on('selectDate', (a, b, c) => {
        // show events list
        selezionaGiorno();
        calendar.evoCalendar('toggleEventList', true);
      })
      .on('selectMonth', (event, mese) => {
        selezionaMese(mese);
      })
      .on('selectMonth', (event, mese) => {
        meseAttivo(mese);
      })
      .on('selectEvent', (event, selectedEvent) => {
        showEvent(selectedEvent);
      })
      .on('selectYear', (event, annosel) => {
        selezionaAnno(annosel);
      });
    const retrievedToken = $("#retrievedToken");
    const idasso = $("#idasso");
    const waitFor = $("#events_waitFor").show();

    const formData = new FormData();
    const now = new Date();
    const date = now.getUTCDate();
    const month = now.getUTCMonth() + 1;
    const year = now.getUTCFullYear();
    const token_lgn = retrievedToken.val();
    const idassoValue = idasso.val();
    const token = toFixed((month / 17) * date, 11);
    const token2 = toFixed((idassoValue / date) * 13.7, 11);
    const mese_corrente = now.getUTCMonth();
    var mese_attivo = '';

    if (mese_corrente == 0) {
      data_scelta = '2022-01-01';
    } else if (mese_corrente == 1) {
      data_scelta = '2022-02-01';
    } else if (mese_corrente == 2) {
      data_scelta = '2022-03-01';
    } else if (mese_corrente == 3) {
      data_scelta = '2022-04-01';
    } else if (mese_corrente == 4) {
      data_scelta = '2022-05-01';
    } else if (mese_corrente == 5) {
      data_scelta = '2022-06-01';
    } else if (mese_corrente == 6) {
      data_scelta = '2022-07-01';
    } else if (mese_corrente == 7) {
      data_scelta = '2022-08-01';
    } else if (mese_corrente == 8) {
      data_scelta = '2022-09-01';
    } else if (mese_corrente == 9) {
      data_scelta = '2022-10-01';
    } else if (mese_corrente == 10) {
      data_scelta = '2022-11-01';
      mese_attivo = 'Novembre';
    } else if (mese_corrente == 11) {
      data_scelta = '2022-12-01';
    }

    formData.append('token_lgn', retrievedToken.val());
    formData.append('idasso', idassoValue);
    formData.append('token', token);
    formData.append('token2', token2);
    //formData.append('data_scelta', data_scelta);

    fetch('<?php echo $rules->get_api_endpoints_for("calendar") ?>', {
      method: 'post',
      mode: 'cors',
      body: formData
    }).then(async (res) => {
      if (res.status != 200) throw 0;

      return res.text();
    }).then((res) => {
      let parts = res.split('|');

      if (parts[0] == 'errore') {
        throw {
          thrown: true,
          error: parts[1]
        }
      }
      return JSON.parse(res);
    }).then((res) => {
      return res[0];
    }).then((res) => {
      if (res.utente_connesso == 'no' || res.utente_connesso == 'tokenNonValido') {
        error.html(`
              <p><?php _e("You're not logged in. Please", "assofacile"); ?> 
                <a href="<?php echo get_page_link(get_option('assofacile_reserved_area_page')) . '?tab=login'; ?>"><?php _e("Login", "assofacile"); ?></a> 
              <?php _e("to see all events", "assofacile"); ?>.</p>
            `);
        errorContainer.fadeIn();
      } else {
        error.html('<a href="<?php echo get_permalink(get_option('assofacile_reserved_area_page')) ?>">Vai alla pagina profilo</a>');
        errorContainer.fadeIn();
      }

      try {
        for (const event of res.eventi) {
          const date = new Date(`${event.data_evento}`);
          dummyEvents.push({
            id: event.idevento,
            date: event.data_evento,
            startTime: event.orario_inizio,
            endTime: event.orario_fine,
            name: event.nome_evento,
            type: event.tipo_evento
          });
        }
      } catch {}

      $("#events_events").evoCalendar({
        theme: 'default',
        todayHighlight: true,
        calendarEvents: dummyEvents,
        language: 'it',

        getExtraMarkup: (event_data) => {
          return `
                   <p><b><?php _e("Start", "assofacile"); ?></b>: <span>${event_data.startTime}</span></p>
                   <p><b><?php _e("End", "assofacile"); ?></b>: <span>${event_data.endTime}</span></p>
                 `;
        }
      });
    }).catch(err => {
      console.log(err);
      let errText;

      if (!err.thrown) {
        errText = "<?php _e('Something went wong', 'assofacile'); ?>!";
      } else {
        errText = err.error;
      }

      error.html(errText);
      errorContainer.show();
    }).finally(() => {
      waitFor.hide();
    });

    function meseAttivo(meseSel) {
      let giorno_attivo = document.getElementById("giorno_sel");
      let giorno_oggi = document.getElementsByClassName("calendar-active");

      let lista_eventi_giorno = document.getElementById("lista_eventi");
      let menu_eventi = document.getElementById("events_events");
      if (giorno_oggi.length == 0) {
        if (giorno_attivo.classList.contains('visibilita')) {
          giorno_attivo.classList.remove('visibilita');
          giorno_attivo.classList.add('nascosto');
        }
        if (lista_eventi_giorno.classList.contains('visibilita')) {
          lista_eventi_giorno.classList.remove('visibilita');
          lista_eventi_giorno.classList.add('nascosto');
        }
        if (menu_eventi.classList.contains("calendar-initialized")) {
          menu_eventi.classList.add("event-hide");
        }
      } else {
        if (giorno_attivo.classList.contains('nascosto')) {
          giorno_attivo.classList.remove('nascosto');
          giorno_attivo.classList.add('visibilita');
        }
        if (lista_eventi_giorno.classList.contains('nascosto')) {
          lista_eventi_giorno.classList.remove('nascosto');
          lista_eventi_giorno.classList.add('visibilita');
        }
      }
    }

    function selezionaGiorno() {
      let giorno_attivo = document.getElementById("giorno_sel");
      let giorno_oggi = document.getElementsByClassName("calendar-active");
      let lista_eventi_giorno = document.getElementById("lista_eventi");
      let menu_eventi = document.getElementById("events_events");
      if (giorno_oggi.length == 0) {
        if (giorno_attivo.classList.contains('visibilita')) {
          giorno_attivo.classList.remove('visibilita');
          giorno_attivo.classList.add('nascosto');
        }
        if (lista_eventi_giorno.classList.contains('visibilita')) {
          lista_eventi_giorno.classList.remove('visibilita');
          lista_eventi_giorno.classList.add('nascosto');
        }
        if (menu_eventi.classList.contains("calendar-initialized")) {
          menu_eventi.classList.add("event-hide");
        }
      } else {
        if (giorno_attivo.classList.contains('nascosto')) {
          giorno_attivo.classList.remove('nascosto');
          giorno_attivo.classList.add('visibilita');
        }
        if (lista_eventi_giorno.classList.contains('nascosto')) {
          lista_eventi_giorno.classList.remove('nascosto');
          lista_eventi_giorno.classList.add('visibilita');
        }
      }
    }

    async function selezionaMese(mese) {
      let anno_sel = document.getElementById("anno_sel").innerText;
      if (mese == "Gennaio") {
        data_scelta = anno_sel + '-01-01';
      } else if (mese == "Febbraio") {
        data_scelta = anno_sel + '-02-01';
      } else if (mese == "Marzo") {
        data_scelta = anno_sel + '-03-01';
      } else if (mese == "Aprile") {
        data_scelta = anno_sel + '-04-01';
      } else if (mese == "Maggio") {
        data_scelta = anno_sel + '-05-01';
      } else if (mese == "Giugno") {
        data_scelta = anno_sel + '-06-01';
      } else if (mese == "Luglio") {
        data_scelta = anno_sel + '-07-01';
      } else if (mese == "Agosto") {
        data_scelta = anno_sel + '-08-01';
      } else if (mese == "Settembre") {
        data_scelta = anno_sel + '-09-01';
      } else if (mese == "Ottobre") {
        data_scelta = anno_sel + '-10-01';
      } else if (mese == "Novembre") {
        data_scelta = anno_sel + '-11-01';
      } else if (mese == "Dicembre") {
        data_scelta = anno_sel + '-12-01';
      }
      const form_data = new FormData();
      for (const entry of formData.entries()) {
        form_data.append(entry[0], entry[1]);
      }
      form_data.append('data_scelta', data_scelta);
      return fetch('<?php echo $rules->get_api_endpoints_for("calendar") ?>', {
          method: 'post',
          mode: 'cors',
          body: form_data
        })
        .then(async (res) => {
          if (res.status != 200) throw 0;

          return res.text();
        }).then((res) => {
          let parts = res.split('|');

          if (parts[0] == 'errore') {
            throw {
              thrown: true,
              error: parts[1]
            }
          }

          return JSON.parse(res);
        })
        .then((res) => {
          return res[0];
        })
        .then((res) => {
          if (res.utente_connesso == 'no' || res.utente_connesso == 'tokenNonValido') {
            error.html(`
            <p><?php _e("You're not logged in. Please", "assofacile"); ?> 
              <a href="<?php echo get_page_link(get_option('assofacile_reserved_area_page')) . '?tab=login'; ?>"><?php _e("Login", "assofacile"); ?></a> 
            <?php _e("to see all events", "assofacile"); ?>.</p>
          `);
            errorContainer.fadeIn();
          } else {
            error.html('<a href="<?php echo get_permalink(get_option('assofacile_reserved_area_page')) ?>">Vai alla pagina profilo</a>');
            errorContainer.fadeIn();
          }
          const eventiMese = [];
          try {
            for (const event of res.eventi) {
              const date = new Date(`${event.data_evento}`);

              dummyEvents.push({
                id: event.idevento,
                date: event.data_evento,
                startTime: event.orario_inizio,
                endTime: event.orario_fine,
                name: event.nome_evento,
                type: event.tipo_evento
              });
              eventiMese.push({
                id: event.idevento,
                date: event.data_evento,
                startTime: event.orario_inizio,
                endTime: event.orario_fine,
                name: event.nome_evento,
                type: event.tipo_evento
              });
            }
          } catch {}

          $("#events_events").evoCalendar({
            theme: 'default',
            todayHighlight: true,
            calendarEvents: dummyEvents,
            language: 'it',

            getExtraMarkup: (event_data) => {
              return `
                    <p><b><?php _e("Start", "assofacile"); ?></b>: <span>${event_data.startTime}</span></p>
                    <p><b><?php _e("End", "assofacile"); ?></b>: <span>${event_data.endTime}</span></p>
                  `;
            }
          });
          return eventiMese;
        }).then((eventiMese) => {
          let date_mese = document.querySelectorAll("div[data-date-val]");
          const arrayDate = [];
          const arrayDateEv = [];
          for (const data_mese of date_mese) {
            let dataMese = new Date(data_mese.dataset.dateVal).toLocaleDateString('it-IT');
            arrayDate.push(dataMese);
          }
          for (const singoloEvento of eventiMese) {
            dataEv = new Date(singoloEvento.date).toLocaleDateString('it-IT');
            dataEv2 = new Date(singoloEvento.date).toLocaleDateString('en-US', {
              year: "numeric",
              month: "2-digit",
              day: "2-digit",
            });
            if (arrayDate.includes(dataEv) && (!arrayDateEv.includes(dataEv2))) {
              arrayDateEv.push(dataEv2);
            }
          }
          for (let i = 0; i < arrayDateEv.length; i++) {
            const dataEvento = arrayDateEv[i];
            let giorni_mese = document.querySelector("div[data-date-val='" + dataEvento + "']");
            let span_indicatori = document.createElement('span');
            span_indicatori.setAttribute("class", "event-indicator");
            let div_indicatori = document.createElement('div');
            div_indicatori.setAttribute("class", "type-bullet");
            let div_tipo_indicatori = document.createElement('div');
            div_tipo_indicatori.setAttribute("class", "type-a");
            div_indicatori.append(div_tipo_indicatori);
            span_indicatori.append(div_indicatori);
            giorni_mese.append(span_indicatori);
          }
        }).catch(err => {
          console.log(err);
          let errText;

          if (!err.thrown) {
            errText = "<?php _e('Something went wrong', 'assofacile'); ?>!";
          } else {
            errText = err.error;
          }

          error.html(errText);
          errorContainer.show();
        })
        .finally(() => {
          waitFor.hide();
        });
    }

    async function selezionaAnno(annosel) {
      let anno_sel = annosel;
      let mese_sel = document.getElementsByClassName("active-month");
      if (mese_sel[0].innerText == "Gennaio") {
        data_scelta = anno_sel + '-01-01';
      } else if (mese_sel[0].innerText == "Febbraio") {
        data_scelta = anno_sel + '-02-01';
      } else if (mese_sel[0].innerText == "Marzo") {
        data_scelta = anno_sel + '-03-01';
      } else if (mese_sel[0].innerText == "Aprile") {
        data_scelta = anno_sel + '-04-01';
      } else if (mese_sel[0].innerText == "Maggio") {
        data_scelta = anno_sel + '-05-01';
      } else if (mese_sel[0].innerText == "Giugno") {
        data_scelta = anno_sel + '-06-01';
      } else if (mese_sel[0].innerText == "Luglio") {
        data_scelta = anno_sel + '-07-01';
      } else if (mese_sel[0].innerText == "Agosto") {
        data_scelta = anno_sel + '-08-01';
      } else if (mese_sel[0].innerText == "Settembre") {
        data_scelta = anno_sel + '-09-01';
      } else if (mese_sel[0].innerText == "Ottobre") {
        data_scelta = anno_sel + '-10-01';
      } else if (mese_sel[0].innerText == "Novembre") {
        data_scelta = anno_sel + '-11-01';
      } else if (mese_sel[0].innerText == "Dicembre") {
        data_scelta = anno_sel + '-12-01';
      }
      const form_data = new FormData();
      for (const entry of formData.entries()) {
        form_data.append(entry[0], entry[1]);
      }
      form_data.append('data_scelta', data_scelta);
      return fetch('<?php echo $rules->get_api_endpoints_for("calendar") ?>', {
          method: 'post',
          mode: 'cors',
          body: form_data
        })
        .then(async (res) => {
          if (res.status != 200) throw 0;

          return res.text();
        }).then((res) => {
          let parts = res.split('|');

          if (parts[0] == 'errore') {
            throw {
              thrown: true,
              error: parts[1]
            }
          }

          return JSON.parse(res);
        })
        .then((res) => {
          return res[0];
        })
        .then((res) => {
          if (res.utente_connesso == 'no' || res.utente_connesso == 'tokenNonValido') {
            error.html(`
            <p><?php _e("You're not logged in. Please", "assofacile"); ?> 
              <a href="<?php echo get_page_link(get_option('assofacile_reserved_area_page')) . '?tab=login'; ?>"><?php _e("Login", "assofacile"); ?></a> 
            <?php _e("to see all events", "assofacile"); ?>.</p>
          `);
            errorContainer.fadeIn();
          } else {
            error.html('<a href="<?php echo get_permalink(get_option('assofacile_reserved_area_page')) ?>">Vai alla pagina profilo</a>');
            errorContainer.fadeIn();
          }
          const eventiMese = [];
          try {
            for (const event of res.eventi) {
              const date = new Date(`${event.data_evento}`);

              dummyEvents.push({
                id: event.idevento,
                date: event.data_evento,
                startTime: event.orario_inizio,
                endTime: event.orario_fine,
                name: event.nome_evento,
                type: event.tipo_evento
              });
              eventiMese.push({
                id: event.idevento,
                date: event.data_evento,
                startTime: event.orario_inizio,
                endTime: event.orario_fine,
                name: event.nome_evento,
                type: event.tipo_evento
              });
            }
          } catch {}

          $("#events_events").evoCalendar({
            theme: 'default',
            todayHighlight: true,
            calendarEvents: dummyEvents,
            language: 'it',

            getExtraMarkup: (event_data) => {
              return `
                    <p><b><?php _e("Start", "assofacile"); ?></b>: <span>${event_data.startTime}</span></p>
                    <p><b><?php _e("End", "assofacile"); ?></b>: <span>${event_data.endTime}</span></p>
                  `;
            }
          });
          return eventiMese;
        }).then((eventiMese) => {
          let date_mese = document.querySelectorAll("div[data-date-val]");
          const arrayDate = [];
          const arrayDateEv = [];
          for (const data_mese of date_mese) {
            let dataMese = new Date(data_mese.dataset.dateVal).toLocaleDateString('it-IT');
            arrayDate.push(dataMese);
          }
          for (const singoloEvento of eventiMese) {
            dataEv = new Date(singoloEvento.date).toLocaleDateString('it-IT');
            dataEv2 = new Date(singoloEvento.date).toLocaleDateString('en-US', {
              year: "numeric",
              month: "2-digit",
              day: "2-digit",
            });
            if (arrayDate.includes(dataEv) && (!arrayDateEv.includes(dataEv2))) {
              arrayDateEv.push(dataEv2);
            }
          }
          for (let i = 0; i < arrayDateEv.length; i++) {
            const dataEvento = arrayDateEv[i];
            let giorni_mese = document.querySelector("div[data-date-val='" + dataEvento + "']");
            let span_indicatori = document.createElement('span');
            span_indicatori.setAttribute("class", "event-indicator");
            let div_indicatori = document.createElement('div');
            div_indicatori.setAttribute("class", "type-bullet");
            let div_tipo_indicatori = document.createElement('div');
            div_tipo_indicatori.setAttribute("class", "type-a");
            div_indicatori.append(div_tipo_indicatori);
            span_indicatori.append(div_indicatori);
            giorni_mese.append(span_indicatori);
          }
        }).catch(err => {
          console.log(err);
          let errText;

          if (!err.thrown) {
            errText = "<?php _e('Something went wrong', 'assofacile'); ?>!";
          } else {
            errText = err.error;
          }

          error.html(errText);
          errorContainer.show();
        })
        .finally(() => {
          waitFor.hide();
        });
    }


    async function showEvent(event) {
      const overlay = $('#modal-overlay')
      overlay.click(() => overlay.fadeOut());

      const modal = $('#eventModal').click((event) => event.stopPropagation());

      const close = $('.modalClose').click('click', () => overlay.fadeOut());
      const title = $("#modalTitle").html('');
      const container = $("#modalBody").html('');

      /**
       * add title row
       */
      title.attr('class', 'flex-fill').text(event.name),

        overlay.fadeIn();

      const details = $(document.createElement('div'));
      try {
        let event_details = eventCache.find(i => i.id == event.id && i.type == event.type);
        if (!event_details)
          event_details = await getEventDetails(event.type, event.id);
        if (event_details.error) {
          throw event_details.error
        };

        details.append(
          $(document.createElement('div'))
          .html(`
                ${ event_details.image
                    ? '<img style="width: 100%; height: auto; border-radius: 10px;" src="' + event_details.image + '">'
                    : ''
                }

                <p><small class="text-primary" style="padding: 2px 4px;">
                  ${event_details.description}
                </small></p>

                <p>
                  <b><?php _e('Location', 'assofacile'); ?></b>:<br>
                  <span>${event_details.location}</span>
                </p>

                <p>
                  <b><?php _e('Email', 'assofacile'); ?></b>:<br>
                  <a href="mailto:${event_details.email}">${event_details.email}</a>
                </p>

                <p>
                  <b><?php _e('Website', 'assofacile'); ?></b>:<br>
                  <a href="${event_details.website}" target="_blank">Open</a>
                </p>

                <p>
                  <b><?php _e('Telephone', 'assofacile'); ?></b>:<br>
                  <a href="tel:${event_details.telephone}">${event_details.telephone}</a>
                </p>
              `)
        );

        if (event_details.hours) {
          const hourDetails = $(document.createElement('div'))
            .append(
              $(document.createElement('h5'))
              .text("<?php _e('Quando', 'assofacile'); ?>")
            );

          const daily = event_details.hours.filter(i => i.type == 'daily');
          if (daily.length) {
            const wrapper = $(document.createElement('div'))
              .attr('style', 'padding: 2px 4px; border-left: 1px solid black; margin-bottom: 4px;');

            hourDetails.append(wrapper);

            wrapper.append(
              $(document.createElement('p'))
              .html("<b><?php _e('Every day', 'assofacile'); ?>:</b>")
            );

            for (const hour of daily) {
              wrapper.append(
                $(document.createElement('p'))
                .html(`
                      <p>
                        <span><?php _e('From', 'assofacile'); ?></span> 
                        <span>${hour.from}</span> 
                        <span><?php _e('To', 'assofacile'); ?></span> 
                        <span>${hour.to}</span> 
                      </p>
                    `)
              )
            }
          }

          const weekly = event_details.hours.filter(i => i.type == 'weekly');
          if (weekly.length) {
            const wrapper = $(document.createElement('div'))
              .attr('style', 'padding: 2px 4px; border-left: 1px solid black; margin-bottom: 4px;');

            hourDetails.append(wrapper);

            wrapper.append(
              $(document.createElement('p'))
              .html("<b><?php _e('Every week', 'assofacile'); ?>:</b>")
            );

            for (const hour of weekly) {
              wrapper.append(
                $(document.createElement('p'))
                .html(`
                      <p>
                        <span>${hour.info}</span> 
                        <span><?php _e('From', 'assofacile'); ?></span> 
                        <span>${hour.from}</span> 
                        <span><?php _e('To', 'assofacile'); ?></span> 
                        <span>${hour.to}</span> 
                      </p>
                    `)
              )
            }
          }

          details.append(hourDetails);
        }

        details.append(`
            <div class="fb-share-button d-flex flex-row-reverse" data-href="https://developers.facebook.com/docs/plugins/"
              data-layout="button" data-size="small" style="padding: 0px 10px;">
              <a target="_blank"
                href="https://www.facebook.com/sharer/sharer.php?u=${event_details.eventURL}&amp;src=sdkpreparse"
                class="fb-xfbml-parse-ignore btn btn-primary btn-sm text-decoration-none d-flex flex-row"
                style="padding: 2px 4px; margin-left: 4px; color: white !important; align-items: center;"
              >
                <i class="fab fa-facebook-f"></i><span style="padding-left: 2px"><?php _e('Share', 'assofacile'); ?></span>
              </a>

              <a target="_blank"
                href="https://twitter.com/intent/tweet?text=${event_details.name} ${event_details.eventURL}"
                class="fb-xfbml-parse-ignore btn btn-primary btn-sm text-decoration-none d-flex flex-row"
                style="padding: 2px 4px; margin-left: 4px; color: white !important; align-items: center;"
              >
                <i class="fab fa-twitter"></i><span style="padding-left: 2px"><?php _e('Tweet', 'assofacile'); ?></span>
              </a>
            </div>
          `)
      } catch (err) {
        details.append(
          $(document.createElement('div'))
          .attr('class', 'text-danger')
          .html(err)
        );
      }

      container.append(details);
    }

    async function getEventDetails(type, eventId) {
      const fd = new FormData();
      for (const entry of formData.entries()) {
        fd.append(entry[0], entry[1]);
      }
      fd.append('tipo_evento', type);
      fd.append('idevento', eventId);

      return fetch('<?php echo $rules->get_api_endpoints_for("event") ?>', {
        body: fd,
        mode: 'cors',
        method: 'post'
      }).then((res) => {
        if (!res.status == 200)
          throw "<?php _e('Something went wrong', 'assofacile'); ?>!";

        return res.text();
      }).then((res) => {
        /**
         * TO FIX
         * Clean up database to avoid escape sequence errors
         */
        return res.replaceAll(/[\r\n]/g, " ");
      }).then((res) => {
        let data;

        try {
          data = JSON.parse(res);
        } catch (err) {
          data = res.split('|');
          if (data[0] == 'errore') {
            throw data[1];
          } else {
            throw "<?php _e('Something went wrong', 'assofacile'); ?>!";
          }
        }

        return data[0];
      }).then((event) => {
        const data = {
          id: eventId,
          name: event.titolo,
          startTime: event.data_inizio,
          endTime: event.data_fine,
          published: event.pubblicato,
          location: event.luogo,
          image: event.immagine,
          imageShared: event.immagine_share,
          eventURL: event.url_evento,
          description: event.descrizione,
          email: event.e_mail,
          website: event.sito_web,
          telephone: event.telefono,
          hours: [],
        };

        if (event.orari) {
          for (const hour of event.orari) {
            data.hours.push({
              type: hour.tipo == "quotidiano" ? "daily" : "weekly",
              info: hour.specifica,
              from: hour.dalle.split(':').slice(0, 2).join(':'),
              to: hour.alle.split(':').slice(0, 2).join(':'),
            });
          }
        }

        return data;
      }).catch(err => {
        return {
          error: err
        }
      });
    }
  });
</script>