<?php
include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');
global $post;
$link = get_permalink($post->ID, false);
$rules = AssoFacileRules::get_instance();
?>

<div class="tab-profile">
  <input type="hidden" name="retrievedToken" id="retrievedToken" value="<?php echo $_COOKIE['assofacile_api_token']; ?>">
  <input type="hidden" name="idasso" id="idasso" value="<?php echo get_option('assofacile_assoc_id'); ?>">
  <h3 class="text-center">Tessere e Ricevute</h3>
  <div class="">
    <div class="progress" id="waitFor" style="display: none;">
      <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%;">
        <span>Loading...</span>
      </div>
    </div>
    <div class="form-group nascosto" id="div_errore">
      <small class="text-danger" id="msg_errore"></small>
    </div>
    <div class="form-group nascosto" id="div_successo">
      <small class="text-success" id="msg_successo"></small>
    </div>
 <!--    <div id="errorContainer" style="display: none;">
      <small id="error" class="text-danger"></small>
    </div> -->
    <div id="cardsAndReceipts" style="display: none;">
    </div>
  </div>
  <!-- modale -->
  <div id="backgroud_modale" class=""></div>
    <div class="modale" tabindex="-1" role="dialog" id="modal">
      <div class="modal-dialog modal-lg" role="document" style="max-height: 75vh !important; overflow: auto; top: 10vh">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close" onclick="chiudiModale('modal', 'backgroud_modale')"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title" id="modalTitle"></h4>
          </div>
          <div class="modal-body" id="modalBody">
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div><!-- /.modale -->


  <a id="downloadLink" style="display: none;" target="_blank" download></a>
</div>

<script>
  /**
  * chiudi modale cliccando sulla icona
  */
  function chiudiModale(idmodale, bgmodale){
    modale = document.getElementById(idmodale);
    div_bg_modale = document.getElementById(bgmodale);
    modale.style.display = 'none';
    if (div_bg_modale.classList.contains("scompare")) {
        div_bg_modale.classList.remove("scompare");
    }
  }
  /**
  * chiudi modale cliccando fuori dalla modale
  */
  window.onclick = function(event) {
    id_modale=document.getElementById('modal');
    div_bg_modale = document.getElementById('backgroud_modale');
    if (event.target == id_modale) {
      id_modale.style.display = 'none';
      if (div_bg_modale.classList.contains("scompare")) {
        div_bg_modale.classList.remove("scompare");
      }
    }
  }
  document.addEventListener("DOMContentLoaded", function() {
    let div_errore = document.getElementById("div_errore");
    let div_successo = document.getElementById("div_successo");
    let msg_errore = document.getElementById("msg_errore");
    let msg_successo = document.getElementById("msg_successo");
    let contenitore = document.getElementById("cardsAndReceipts");
    contenitore.style.display = 'none';
    let waitFor = document.getElementById("waitFor");
    waitFor.style.display = 'block';
    let valore_token=document.getElementById("retrievedToken").value;
    let idassoValue = document.getElementById("idasso").value;
    let div_bg_modale = document.getElementById('backgroud_modale');
    const formData = new FormData();
    const now = new Date();
    const date = now.getUTCDate();
    const month = now.getUTCMonth() + 1;
    const token = toFixed((month / 17) * date, 11);
    const token2 = toFixed((idassoValue / date) * 13.7, 11);
    formData.append('token_lgn', valore_token);
    formData.append('idasso', idassoValue);
    formData.append('token', token);
    formData.append('token2', token2);

    fetch('<?php echo $rules->get_api_endpoints_for("receipts") ?>', {
      method: 'post',
      mode: 'cors',
      body: formData
    }).then((res) => {
      if (res.status != 200) throw 0;
      return res.text();
    }).then((res) => {
      let data;
      try {
        data = JSON.parse(res);
      } catch (err) {
        data = res.split('|');
        if (data[0] == 'errore') {
          throw data[1];
        } else {
          throw "Qualcosa è andato storto!";
        }
      }
      return data[0];
    }).then((res) => {
      const data = {};
      if (res.tessere_annuali) {
        data.membership = [];
        for (const receipt of res.tessere_annuali) {
          data.membership.push({
            id: receipt.idricevuta,
            year: receipt.anno,
            number: receipt.numero_tessera,
            type: receipt.tipo_tessera,
            paymentDate: receipt.data_pagamento,
            amount: receipt.importo
          });
        }
      }
      if (res.altre_quote) {
        data.other = [];
        for (const receipt of res.altre_quote) {
          const rec = {
            activity: receipt.attivita,
            startDate: receipt.data_inizio,
            endDate: receipt.data_fine,
            deadlines: []
          };
          if (receipt.scadenze) {
            for (const deadline of receipt.scadenze) {
              const dl = {
                deadline: deadline.scadenza,
                type: deadline.tipo_quota,
                receipts: []
              };
              for (const rec1 of deadline.ricevute) {
                dl.receipts.push({
                  id: rec1.idricevuta,
                  paymentNumber: rec1.numero_pagamento,
                  data: rec1.dati_ricevuta,
                  date: rec1.data_ricevuta,
                  paymentName: rec1.nome_quota,
                  amount: rec1.importo_quota,
                  amountPaid: rec1.importo_versato,
                  notes: rec1.note
                });
              }
              rec.deadlines.push(dl);
            }
          }
          data.other.push(rec);
        }
      }
      return data;
    }).then((data) => {
      if (data.membership && data.membership.length) {
        if (div_errore.classList.contains("visibilita")) {
            div_errore.classList.remove("visibilita");
            div_errore.classList.add("nascosto");
          }
          msg_errore.innerText="";
        let div = document.createElement('div');
        let h4 = document.createElement('h4');
        h4.innerText="Tessere e Ricevute Quote Sociali";
        div.append(h4);
        let table = document.createElement('table');
        table.setAttribute('class', 'table');
        let tr = document.createElement('tr');
        let th1 = document.createElement('th');
        th1.innerText="ID";
        let th2 = document.createElement('th');
        th2.innerText="Numero";
        let th3 = document.createElement('th');
        th3.innerText="Tipo";
        let th4 = document.createElement('th');
        th4.innerText="Data pagamento";
        let th5 = document.createElement('th');
        th5.innerText="Importo";
        let th6 = document.createElement('th');
        th6.innerText="";
        tr.append(th1,th2,th3,th4,th5,th6);
        table.append(tr);
        for (const mem of data.membership) {
          let tr = document.createElement('tr');
          let td1 = document.createElement('td');
          td1.innerText=mem.id;
          let td2 = document.createElement('td');
          td2.innerText=mem.number;
          let td3 = document.createElement('td');
          td3.innerText=mem.type;
          let td4 = document.createElement('td');
          if (mem.paymentDate) {
            td4.innerText=new Date(mem.paymentDate).toLocaleDateString(); 
          }else{
            td4.innerText='';
          }
          let td5 = document.createElement('td');
          td5.innerText=mem.amount;
          let td6 = document.createElement('td');
          let btn = document.createElement('button');
          btn.setAttribute('class', 'btn btn-sm btn-default');
          btn.innerHTML=`<span class="fas fa-download"></span>`;
          btn.addEventListener('click', (event) => {
            downloadReceipt('tessere_annuali', mem, event.currentTarget)
          });
          td6.append(btn);
          tr.append(td1,td2,td3,td4,td5,td6);
          table.append(tr);
        }
        div.append(table);
        contenitore.append(div);
      } else {
        if (div_errore.classList.contains("nascosto")) {
            div_errore.classList.remove("nascosto");
            div_errore.classList.add("visibilita");
          }
          msg_errore.innerText="Nessuna tessera/ricevuta presente";
      }

      if (data.other && data.other.length) {
        if (div_errore.classList.contains("visibilita")) {
            div_errore.classList.remove("visibilita");
            div_errore.classList.add("nascosto");
          }
          msg_errore.innerText="";
        let div = document.createElement('div');
        let h4 = document.createElement('h4');
        h4.innerText="Ricevute Quote Attività e Corsi";
        div.append(h4);
        let table = document.createElement('table');
        table.setAttribute('class', 'table');
        let tr = document.createElement('tr');
        let th1 = document.createElement('th');
        th1.innerText="Modulistica Attività e Corsi";
        let th2 = document.createElement('th');
        th2.innerText="Inizio";
        let th3 = document.createElement('th');
        th3.innerText="Fine";
        tr.append(th1,th2,th3);
        table.append(tr);
        for (const doc of data.other) {
          let tr = document.createElement('tr');
          tr.setAttribute('class', 'linked');
          tr.addEventListener('click', () => {
            showDetails(doc)
          });
          let td1 = document.createElement('td');
          td1.innerText=doc.activity;
          let td2 = document.createElement('td');
          if (doc.startDate) {
            td2.innerText=new Date(doc.startDate).toLocaleDateString();
          }else{
            td2.innerText='';
          }
          let td3 = document.createElement('td');
          if (doc.endDate) {
            td3.innerText=new Date(doc.endDate).toLocaleDateString();
          }else{
            td3.innerText='';
          }
          tr.append(td1,td2,td3);
          table.append(tr);
        }
        div.append(table);
        contenitore.append(div);
      } else {          
        if (div_errore.classList.contains("nascosto")) {
            div_errore.classList.remove("nascosto");
            div_errore.classList.add("visibilita");
          }
          msg_errore.innerText="Nessuna tessera/ricevuta presente";
      }
    }).catch(error => {
      console.log(error);
      let errore = '';
      if (
        error == 'Token di login scaduto' ||
        error == 'Token di login inesistente'
      ) {
        window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=profile'; ?>";
        return;
      }else{
        errore = error.error;
      }
      msg_errore.innerHTML=errore;
      if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
      }
    }).finally(() => {
      waitFor.style.display = 'none';
      contenitore.style.display='block';
    });
    /**
    * mostra dettagli 
    */
    function showDetails(activity) {
      let modale = document.getElementById("modal");
      let titolo_modale = document.getElementById("modalTitle");
      titolo_modale.innerHTML='';
      let contenitore_modale = document.getElementById("modalBody");
      contenitore_modale.innerHTML='';
      /**
       * titolo della modale
      */
      titolo_modale.setAttribute('class', 'flex-fill');
      titolo_modale.innerText=activity.activity;
      /**
       * dettagli
       */
      let div = document.createElement('div');
      if (activity.deadlines && !activity.deadlines.length) {
        let div_2 = document.createElement('div');
        div_2.setAttribute('style', 'padding: 10px');
        div_2.setAttribute('class', 'text-info');
        div_2.innerText="Nessuna scadenza trovata!";
        div.append(div_2);
      }
      for (let i = 0; i < activity.deadlines.length; i++) {
        //const deadline = activity.deadlines[i];
       // const deadlineDetails = $(document.createElement('div'));
        let scadenza = activity.deadlines[i];
        let div_scad = document.createElement('div');
        let div_scad2 = document.createElement('div');
        div_scad2.innerHTML=`
              <h5>Scadenza:</h5>
               <p>${scadenza.deadline}</p>
              <h5>Tipo:</h5>
              <p>${scadenza.type}</p>
            `;
      div_scad.append(div_scad2);
      let table = document.createElement('table');
      table.setAttribute('class', 'table');
      let tr = document.createElement('tr');
      let th1 = document.createElement('th');
      th1.innerText="ID";
      let th2 = document.createElement('th');
      th2.innerText="Numero pagamento";
      let th3 = document.createElement('th');
      th3.innerText="Data";
      let th4 = document.createElement('th');
      th4.innerText="N.Ricevuta";
      let th5 = document.createElement('th');
      th5.innerText="Importo";
      let th6 = document.createElement('th');
      th6.innerText="Importo pagato";
      let th7 = document.createElement('th');
      th7.innerText="Note";
      let th8 = document.createElement('th');
      th8.innerText="";
      tr.append(th1,th2,th3,th4,th5,th6,th7,th8);
      table.append(tr);
        for (const receipt of scadenza.receipts) {
          let tr = document.createElement('tr');
          let td1 = document.createElement('td');
          td1.innerText=receipt.id;
          let td2 = document.createElement('td');
          td2.innerText=receipt.paymentNumber;
          let td3 = document.createElement('td');
          if (receipt.date) {
            td3.innerText=new Date(receipt.date).toLocaleDateString();
          }else{
            td3.innerText='';
          }
          let td4 = document.createElement('td');
          td4.innerText=receipt.data;
          let td5 = document.createElement('td');
          td5.innerText=receipt.amount;
          let td6 = document.createElement('td');
          td6.innerText=receipt.amountPaid;
          let td7 = document.createElement('td');
          td7.innerText=receipt.notes;
          let td8 = document.createElement('td');
          let btn = document.createElement('button');
          btn.setAttribute('class', 'btn btn-sm btn-default');
          btn.innerHTML=`<span class="fas fa-download"></span>`;
          btn.addEventListener('click', (event) => {
            downloadReceipt('altre_quote', receipt, event.currentTarget)
          });
          td8.append(btn);
          tr.append(td1,td2,td3,td4,td5,td6,td7,td8);
          table.append(tr);
        }
        div_scad.append(table);
        div.append(div_scad);
      }
      contenitore_modale.append(div);
      if (modale.style.display ='none' && (!div_bg_modale.classList.contains("scompare"))) {
        div_bg_modale.classList.add("scompare");
        modale.style.display ='block';
      }
    }
    /**
    * download documenti
    */
    function downloadReceipt(type, receipt, element) {
      jElement = element;
      let originalHtml = jElement.innerHTML;
      jElement.innerHTML='<i class="fas fa-spinner"></i>';

      const formData1 = new FormData();
      for (const e of formData.entries()) {
        formData1.append(e[0], e[1]);
      };
      formData1.append('tipo_ricevuta', type);
      formData1.append('idricevuta', receipt.id);
      fetchProgress('<?php echo $rules->get_api_endpoints_for("receipt") ?>', {
        method: 'post',
        body: formData1,
        mode: 'cors',
      }, 'json', (progress) => {}).then((res) => {
        return res[0].file[0];
      }).then(async (res) => {
        const data = await base64ToBufferAsync(res.data);
        const file = new File([data], res.filename, {
          type: res["content-type"]
        });
        const url = URL.createObjectURL(file);
        let downloadLink = document.getElementById("downloadLink");
        downloadLink.setAttribute('href', url);
        downloadLink.click();
        jElement.innerHTML=originalHtml;
      });
    }
  });
</script>