<?php
include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');
global $post;
$link = get_permalink($post->ID, false);
$rules = AssoFacileRules::get_instance();
?>
<div class="tab-profile">
  <input type="hidden" name="retrievedToken" id="retrievedToken" value="<?php echo $_COOKIE['assofacile_api_token']; ?>">
  <input type="hidden" name="idasso" id="idasso" value="<?php echo get_option('assofacile_assoc_id'); ?>">
  <h3 class="text-center">Documenti</h3>
  <div class="">
    <div class="progress" id="waitFor" style="display: none;">
      <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%;">
        <span>Loading...</span>
      </div>
    </div>
    <div class="form-group nascosto" id="div_errore">
      <small class="text-danger" id="msg_errore"></small>
    </div>
    <div class="form-group nascosto" id="div_successo">
      <small class="text-success" id="msg_successo"></small>
    </div>
    <div id="cardsAndDocs" style="display: none;">
    </div>
  </div>
  <!-- The modal -->
  <div id="backgroud_modale" class=""></div>
  <div class="modale" tabindex="-1" role="dialog" id="modal">
    <div class="modal-dialog modal-lg" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-label="Close" onclick="chiudiModale('modal', 'backgroud_modale')"><span aria-hidden="true">&times;</span></button>
          <h4 class="modal-title" id="modalTitle"></h4>
        </div>
        <div class="modal-body" id="modalBody">
        </div>
      </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
  </div><!-- /.modal -->
  <a id="downloadLink" style="display: none;" target="_blank" download></a>
</div>

<script>
  /**
  * chiudi modale cliccando sulla icona
  */
  function chiudiModale(idmodale, bgmodale){
    modale = document.getElementById(idmodale);
    div_bg_modale = document.getElementById(bgmodale);
    modale.style.display = 'none';
    if (div_bg_modale.classList.contains("scompare")) {
        div_bg_modale.classList.remove("scompare");
    }
  }
  /**
  * chiudi modale cliccando fuori dalla modale
  */
  window.onclick = function(event) {
    id_modale=document.getElementById('modal');
    div_bg_modale = document.getElementById('backgroud_modale');
    if (event.target == id_modale) {
      id_modale.style.display = 'none';
      if (div_bg_modale.classList.contains("scompare")) {
        div_bg_modale.classList.remove("scompare");
      }
    }
  }
  document.addEventListener("DOMContentLoaded", function() {
    let div_errore = document.getElementById("div_errore");
    let div_successo = document.getElementById("div_successo");
    let msg_errore = document.getElementById("msg_errore");
    let msg_successo = document.getElementById("msg_successo");
    let contenitore = document.getElementById("cardsAndDocs");
    contenitore.style.display = 'none';
    let waitFor = document.getElementById("waitFor");
    waitFor.style.display = 'block';
    let valore_token=document.getElementById("retrievedToken").value;
    let idassoValue = document.getElementById("idasso").value;
    let div_bg_modale = document.getElementById('backgroud_modale');
    const formData = new FormData();
    const now = new Date();
    const date = now.getUTCDate();
    const month = now.getUTCMonth() + 1;
    const token = toFixed((month / 17) * date, 11);
    const token2 = toFixed((idassoValue / date) * 13.7, 11);

    formData.append('token_lgn', valore_token);
    formData.append('idasso', idassoValue);
    formData.append('token', token);
    formData.append('token2', token2);
    /**
    * mostra tutti i documenti
    */
    fetch('<?php echo $rules->get_api_endpoints_for("docs") ?>', {
      method: 'post',
      mode: 'cors',
      body: formData
    }).then((res) => {
      if (res.status != 200) throw 0;
      return res.text();
    }).then((res) => {
      let data;
      try {
        data = JSON.parse(res);
      } catch (err) {
        data = res.split('|');
        if (data[0] == 'errore') {
          throw data[1];
        } else {
          throw "Qualcosa è andato storto!";
        }
      }
      return data[0];
    }).then((res) => {
      const data = {};
      if (res.docs_generali) {
        data.general = [];
        for (const mod of res.docs_generali) {
          data.general.push({
            id: mod.idmodulo,
            name: mod.nome_modulo,
            description: mod.descrizione_modulo,
            uploadStatus: mod.status_caricamento
          });
        }
      }
      if (res.docs_attivita) {
        data.activities = [];
        for (const activity of res.docs_attivita) {
          const act = {
            id: activity.idattivita,
            name: activity.nome_attivita,
            modules: []
          };
          if (activity.moduli) {
            for (const _module of activity.moduli) {
              const mod = {
                id: _module.idmodulo,
                name: _module.nome_modulo,
                type: _module.tipo_modulo,
                fileId: _module.idfile_compilato,
                fileDescription: _module.descrizione_file,
                allowUpload: _module.consenti_caricamento == 'si' ? true : false
              };
              if (mod.allowUpload) {
                mod.fileField = {
                  name: _module.campo_file[0].name,
                  id: _module.campo_file[0].id,
                };
              }
              act.modules.push(mod);
            }
          }
          data.activities.push(act);
        }
      }
      return data;
    }).then((data) => {
        if (data.general.length == 0 || data.activities.length == 0) {
        if (div_errore.classList.contains("nascosto")) {
            div_errore.classList.remove("nascosto");
            div_errore.classList.add("visibilita");
          }
          msg_errore.innerText="Nessun documento presente";
      }else if (data.general.length || data.activities.length) {
        if (div_errore.classList.contains("visibilita")) {
            div_errore.classList.remove("visibilita");
            div_errore.classList.add("nascosto");
          }
          msg_errore.innerText="";
      }
      if (data.general && data.general.length) {
        if (div_errore.classList.contains("visibilita")) {
          div_errore.classList.remove("visibilita");
          div_errore.classList.add("nascosto");
        }
        let div = document.createElement('div');
        let h4 = document.createElement('h4');
        h4.innerText="Modulistica Iscrizioni";
        div.append(h4);
        let table = document.createElement('table');
        table.setAttribute('class', 'table');
        let tr = document.createElement('tr');
        let th1 = document.createElement('th');
        th1.innerText="ID";
        let th2 = document.createElement('th');
        th2.innerText="Nome";
        let th3 = document.createElement('th');
        th3.innerText="Descrizione";
        let th4 = document.createElement('th');
        th4.innerText="Stato/Carica File";
        let th5 = document.createElement('th');
        th5.innerText="";
        tr.append(th1,th2,th3,th4,th5);
        table.append(tr);
        for (const gen of data.general) {
          let tr = document.createElement('tr');
          let td1 = document.createElement('td');
          td1.innerText=gen.id;
          let td2 = document.createElement('td');
          td2.innerText=gen.name;
          let td3 = document.createElement('td');
          td3.innerText=gen.description;
          let td4 = document.createElement('td');
          td4.innerText=gen.uploadStatus;
          let td5 = document.createElement('td');
          let btn = document.createElement('button');
          btn.setAttribute('class', 'btn btn-sm btn-default');
          btn.innerHTML=`<span class="fas fa-download"></span>`;
          btn.addEventListener('click', (event) => {
            downloadDoc('docs_generali', gen, event.currentTarget)
          });
          td5.append(btn);
          tr.append(td1,td2,td3,td4,td5);
          table.append(tr);
        }
        div.append(table);
        contenitore.append(div);
      }

      if (data.activities && data.activities.length) {
        let div = document.createElement('div');
        let h4 = document.createElement('h4');
        h4.innerText="Modulistica Attività e Corsi";
        div.append(h4);
        let table = document.createElement('table');
        table.setAttribute('class', 'table');
        let tr = document.createElement('tr');
        let th1 = document.createElement('th');
        th1.innerText="ID";
        let th2 = document.createElement('th');
        th2.innerText="Nome";
        tr.append(th1,th2);
        table.append(tr);
        for (const act of data.activities) {
          let tr = document.createElement('tr');
          tr.setAttribute('class', 'linked');
          tr.addEventListener('click', () => {
            showDetails(act)
          });
          let td1 = document.createElement('td');
          td1.innerText=act.id;
          let td2 = document.createElement('td');
          td2.innerText=act.name;
          tr.append(td1,td2);
          table.append(tr);
        }
        div.append(table);
        contenitore.append(div);
      }
    }).catch(error => {
      console.log(error);
      let errore = '';
      if (
        error == 'Token di login scaduto' ||
        error == 'Token di login inesistente'
      ) {
        window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=profile'; ?>";
        return;
      }
      errore = error;
      msg_errore.innerHTML=errore;
      if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
      }
    }).finally(() => {
      waitFor.style.display = 'none';
      contenitore.style.display='block';
    });
    /**
    * mostra dettagli 
    */
    function showDetails(activity) {
      let modale = document.getElementById("modal");
      let titolo_modale = document.getElementById("modalTitle");
      titolo_modale.innerHTML='';
      let contenitore_modale = document.getElementById("modalBody");
      contenitore_modale.innerHTML='';
      /**
       * titolo della modale
      */
      titolo_modale.setAttribute('class', 'flex-fill');
      titolo_modale.innerText=activity.name;
      /**
      * dettagli
      */
      let div = document.createElement('div');
      if (activity.modules && !activity.modules.length) {
        let div_2 = document.createElement('div');
        div_2.setAttribute('style', 'padding: 10px');
        div_2.setAttribute('class', 'text-info');
        div_2.innerText="Nessun modulo trovato!";
        div.append(div_2);
      }
      let table = document.createElement('table');
      table.setAttribute('class', 'table');
      let tr = document.createElement('tr');
      let th1 = document.createElement('th');
      th1.innerText="ID";
      let th2 = document.createElement('th');
      th2.innerText="Nome";
      let th3 = document.createElement('th');
      th3.innerText="Tipo";
      let th4 = document.createElement('th');
      th4.innerText="File ID";
      let th5 = document.createElement('th');
      th5.innerText="File Descizione";
      let th6 = document.createElement('th');
      th6.innerText="";
      tr.append(th1,th2,th3,th4,th5,th6);
      table.append(tr);
      for (let i = 0; i < activity.modules.length; i++) {
        const _module = activity.modules[i];
        let tr = document.createElement('tr');
        let td1 = document.createElement('td');
        td1.innerText=_module.id;
        let td2 = document.createElement('td');
        td2.innerText=_module.name;
        let td3 = document.createElement('td');
        td3.innerText=_module.type;
        let td4 = document.createElement('td');
        td4.innerText=_module.fileId;
        let td5 = document.createElement('td');
        td5.innerText=_module.fileDescription;
        let td6 = document.createElement('td');
        let div_td6 = document.createElement('div');
        div_td6.setAttribute('class', 'd-flex flex-row align-items-center');
        div_td6.setAttribute('style', 'padding: 0px 2px');
        let btn = document.createElement('button');
        btn.setAttribute('class', 'btn btn-default btn-sm fa-button');
        btn.setAttribute('style', 'margin-right: 2px !important');
        btn.addEventListener('click', (event) => {
          downloadDoc('docs_attivita', _module, event.currentTarget)
        });
        let i_btn = document.createElement('i');
        i_btn.setAttribute('class', 'fas fa-download');

        let btn2 = document.createElement('button');
        btn2.setAttribute('class', 'btn btn-primary btn-sm fa-button');
        btn2.addEventListener('click', () => {
          document.getElementById("moduleName").innerText=_module.name;
          document.getElementById("moduleType").value='docs_attivita';
          document.getElementById("moduleId").value=_module.id;
          let img_file =  document.getElementById("imagefile_file");
          img_file.setAttribute('name', _module.fileField.name);
          let form_upd =  document.getElementById("activityModuleUploadForm");
          form_upd.style.display = 'block';
        });
        let i_btn2 = document.createElement('i');
        i_btn2.setAttribute('class', 'fas fa-upload');
        let span_btn = document.createElement('span');
        btn2.append(i_btn2);
        btn.append(i_btn);
        div_td6.append(btn);
        if (_module.allowUpload) {
          div_td6.append(btn2);
        }else{
          div_td6.append(span_btn);
        }
        td6.append(div_td6);
        tr.append(td1,td2,td3,td4,td5,td6);
        table.append(tr);
      }
      /**
      * creazione form upload
      */
      let uploadForm = document.createElement('form');
      uploadForm.setAttribute('id', 'activityModuleUploadForm');
      uploadForm.addEventListener('submit', uploadFiles);
        let h3_u = document.createElement('h3');
        h3_u.innerText='Carica Altro';
        let div_u = document.createElement('div');
        let b_u = document.createElement('b');
        b_u.innerText='Modulo Nome:';
        let span_u = document.createElement('span');
        span_u.setAttribute('id', 'moduleName');
        div_u.append(b_u, span_u);
        let intup_u = document.createElement('input');
        intup_u.setAttribute('type', 'hidden');
        intup_u.setAttribute('name', 'tipo_modulo');
        intup_u.setAttribute('id', 'moduleType');
        intup_u.setAttribute('value', '');
        let intup_u2 = document.createElement('input');
        intup_u2.setAttribute('type', 'hidden');
        intup_u2.setAttribute('name', 'idmodulo');
        intup_u2.setAttribute('id', 'moduleId');
        intup_u2.setAttribute('value', '');
        let intup_u3 = document.createElement('input');
        intup_u3.setAttribute('class', 'form-control');
        intup_u3.setAttribute('type', 'file');
        intup_u3.setAttribute('name', '');
        intup_u3.setAttribute('id', 'imagefile_file');
        intup_u3.setAttribute('accept', '<?php echo $rules->get_attachement_types_for(); ?>');
        let div_u2 = document.createElement('div');
        let intup_u4 = document.createElement('input');
        intup_u4.setAttribute('class', 'btn btn-primary');
        intup_u4.setAttribute('type', 'submit');
        intup_u4.setAttribute('name', 'submit');
        intup_u4.setAttribute('value', 'Upload');
        div_u2.append(intup_u4);
        uploadForm.append(div_u2);
        uploadForm.append(intup_u3);
        uploadForm.append(intup_u2);
        uploadForm.append(intup_u);
        uploadForm.append(div_u);
        uploadForm.append(h3_u);
      uploadForm.style.display = 'none';
      div.append(table, uploadForm);
      contenitore_modale.append(div);
      if (modale.style.display ='none' && (!div_bg_modale.classList.contains("scompare"))) {
        div_bg_modale.classList.add("scompare");
        modale.style.display ='block';
      }
    }  
    /**
    * download documenti
    */
    function downloadDoc(type, _module, element) {
      jElement = element;
      let originalHtml = jElement.innerHTML;
      jElement.innerHTML='<i class="fas fa-spinner"></i>';
      const formData1 = new FormData();
      for (const e of formData.entries()) {
        formData1.append(e[0], e[1]);
      };
      formData1.append('tipo_modulo', type);
      formData1.append('idmodulo', _module.id);
      fetchProgress('<?php echo $rules->get_api_endpoints_for("doc") ?>', {
        method: 'post',
        body: formData1,
        mode: 'cors'
      }).then((res) => {
        if (res.status != 200) throw 0;
        return res.text();
      }).then((res) => {
        let parts = res.split('|');
        let small_error = document.getElementById("msg_errore");
        if (!(parts[0] == 'errore')) {
          if (div_errore.classList.contains("visibilita")) {
          div_errore.classList.remove("visibilita");
          div_errore.classList.add("nascosto");
          }
        }
        if (parts[0] == 'errore') {
          throw {
            thrown: true,
            error: parts[1]
          }
        }
        return JSON.parse(res);
      }).then((res) => {
        return res[0].file[0];
      }).then(async (res) => {
        const data = await base64ToBufferAsync(res.data);
        const file = new File([data], res.filename, {
          type: res["content-type"]
        });
        const url = URL.createObjectURL(file);
        let downloadLink=  document.getElementById("downloadLink");
        downloadLink.setAttribute('href', url);
        downloadLink.click();
        jElement.innerHTML=originalHtml;
      }).catch(error => {
        console.log(error);
        let errore = '';
        if (!error.thrown) {
          errore = "Qualcosa è andato storto!";
        } else {
          errore = error.error;
        }
        msg_errore.innerHTML=errore;
        if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
        }
      });
    }
    /**
    * caricamento documenti
    */
    function uploadFiles(event) {
      event.preventDefault();
      const form = document.getElementById("activityModuleUploadForm");
      const originalHTML = form.innerHTML;
      const formData1 = new FormData(form);
      for (const e of formData.entries()) {
        formData1.append(e[0], e[1]);
      }
      let div_p = document.createElement('div');
      div_p.setAttribute('class', 'progress');
      let div_p2 = document.createElement('div');
      div_p2.setAttribute('class', 'progress-bar progress-bar-success progress-bar-striped');
      div_p2.setAttribute('role', 'progressbar');
      div_p2.setAttribute('aria-valuenow', '40');
      div_p2.setAttribute('aria-valuemin', '0');
      div_p2.setAttribute('aria-valuemax', '100');
      div_p2.setAttribute('style', 'width: 100%; text-align: center;');
      let span_p = document.createElement('span');
      span_p.innerText='Caricamento...';
      div_p2.append(span_p);
      div_p.append(div_p2);
      form.append(div_p);
      fetch('<?php echo $rules->get_api_endpoints_for("upload") ?>', {
        method: 'post',
        mode: 'cors',
        body: formData1
      }).then((res) => {
        if (res.status != 200)
          throw "Qualcosa è andato storto!";
        return res.text();
      }).then((res) => {
        const parts = res.split('|');
        if (!parts.length)
          return "Il file è stato caricato correttamente!";
        if (parts[0] == 'errore') {
          throw parts[1];
        } else {
          return parts[1];
        }
      }).then((res) => {
        let div_pp = document.createElement('div');
        div_pp.setAttribute('class', 'panel panel-success');
        let div_pp2 = document.createElement('div');
        div_pp2.setAttribute('class', 'panel-header');
        div_pp2.innerText=res;
        div_pp.append(div_pp2);
        form.append(div_pp);
      }).catch(error => {
        console.log(error);
        let errore = null;
        if (errore instanceof String || typeof errore == 'string') {
          error = errore;
        } else {
          error = "Qualcosa è andato storto!";
        }
        msg_errore.innerHTML=error;
        if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
        }
        let div_ps = document.createElement('div');
        div_ps.setAttribute('class', 'panel panel-danger');
        let div_ps2 = document.createElement('div');
        div_ps2.setAttribute('class', 'panel-header');
        div_ps2.innerText=res;
        div_ps.append(div_ps2);
        form.append(div_ps);
      });
    }
  });
</script>