<?php
include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');
global $post;
$link = get_permalink($post->ID, false);
$rules = AssoFacileRules::get_instance();
$expired_display = "none";
if (isset($_GET["redirect_tab"])) {
  $expired_display = "block";
}
?>
<div class="m-auto">
  <div class="card">
    <div class="d-flex flex-row justify-content-center card-title align-items-baseline">
      <h2>AssoFacile</h2>
      <h3 class="ml-2">Login</h3>
    </div>
    <p class="p_t_tut">Se sei un <span class="span_t_tut">tutore</span> seleziona la casella "accesso tutori/genitori".</p>
    <div class="card-body">
      <form class="form rounded border-1 border-primary" id="loginForm" method="post">
        <input type="hidden" name="idasso" id="idasso" value="<?php echo get_option('assofacile_assoc_id'); ?>">
        <small class="text-info" style="padding: 4px; display: <?php echo $expired_display; ?>">
         Login scaduto. Si prega di effettuare un nuovo accesso!
        </small>
        <div class="form-group">
          <label for="tutore" class="lab_tut">
          <input type="checkbox" inputmode="tutore" name="tutore" id="tutore">
          accesso tutori/genitori</label>
        </div>
        <div class="form-group">
          <label for="email">Indirizzo Email</label>
          <input type="email" class="form-control" inputmode="email" name="uid" id="uid" required>
        </div>
        <div class="form-group">
          <label for="password">Password</label>
          <input type="password" class="form-control" name="pwd" id="pwd" required>
        </div>
        <div class="form-group" id="div_errore" class="nascosto">
          <span class="text-danger" id="msg_errore"></span>
        </div>
        <div class="form-group d-flex flex-row justify-content-around">
          <button class="btn btn-sm btn-primary" type="submit">Login</button>
          <a href="<?php echo $link . '?tab=register'; ?>">
            <span style="margin-left: 10px">Registrazione</span>
          </a>
        </div>
        <a href="https://www.assofacile.it/login/cp_plugin.php?idasso=<?php echo get_option('assofacile_assoc_id'); ?>" id="link_recupero_pwd" target="_blank">
          <span>Clicca qui per il link "Password dimenticata"</span>
        </a>
      </form>
      <form class="d-none" style="visibility: hidden;" id="finishForm" method="post" action="<?php echo $link; ?>">
        <input type="hidden" name="retrievedToken" id="retrievedToken" value="">
        <input type="hidden" name="tokenLgn" id="tokenLgn" value="">
      </form>
    </div>
  </div>
</div>

<script>
  let div_errore = document.getElementById("div_errore");
  let msg_errore = document.getElementById("msg_errore");
  let retrievedToken = document.getElementById("retrievedToken");
  let finishForm = document.getElementById("finishForm");
  let check_tutore = '';
  let tabs = '';
  const form = document.getElementById("loginForm");
  form.addEventListener("submit", formSubmit);
  function formSubmit(e) {
  e.preventDefault()
  let formData = new FormData();
  const now = new Date();
  const date = now.getUTCDate();
  const month = now.getUTCMonth() + 1;
  const idassoValue = document.getElementById("idasso").value;
  const uid = document.getElementById("uid").value;
  const pwd = document.getElementById("pwd").value;
  const token = toFixed((month / 17) * date, 11);
  const token2 = toFixed(((idassoValue / date) * 13.7), 11);
  if (document.getElementById('tutore').checked) {
      check_tutore = 'si';
  } else {
      check_tutore = 'no';
  }
  formData.append('idasso', idassoValue);
  formData.append('uid', uid);
  formData.append('pwd', pwd);
  formData.append('token', token);
  formData.append('token2', token2);
  formData.append('check_tutore', check_tutore);
  fetch("<?php echo $rules->get_api_endpoints_for("login") ?>",
  {
    method: "POST",
    body: formData,
    mode: 'cors'
  }).then((response) => {
      if (response.status != 200) throw 0;
      return response.text();
  }).then((response) => {
        const parts = response.split('|');
        if (parts[0] != 'ok') {
          throw {
            thrown: true,
            msg_errore: parts[1]
          }
        }
      retrievedToken.value=parts[1];
      tokenLgn.value=parts[1];
       if (check_tutore != 'si') {
        tabs = parts[3].split(',');
       }else{
        tabs = parts[2].split(',');
       }
      let checkbox = document.querySelectorAll("input[type='checkbox']");
      for(let i = 0; i < checkbox.length; i++){
        if(checkbox){
          rimuoviElemento(checkbox[i]);    
        }
      }
      function rimuoviElemento(elemento){
        elemento.parentElement.removeChild(elemento);
      }
        for (const tab of tabs) {
          var nuovo_checkbox = document.createElement('input');
          nuovo_checkbox.setAttribute('type','checkbox');
          nuovo_checkbox.setAttribute('style','display: none;');
          nuovo_checkbox.setAttribute('value',getMappedTab(tab));
          nuovo_checkbox.setAttribute('checked',true);
          nuovo_checkbox.setAttribute('name','tabs[]');
          finishForm.append(nuovo_checkbox);
        }
        finishForm.submit();
        function getMappedTab(tab) {
          if (tab == "calendario") return "calendar";
          if (tab == "quote") return "cards_and_recipts";
          if (tab == "docs") return "documents";
          if (tab == "comunicazioni") return "messaging";
          if (tab == "profilo") return "profile";
          if (tab == "tutelati") return "tutelati";
        }
      }).catch(error => {
        console.log(error)
        let errore = '';
        if (error.thrown) {
          errore = error.msg_errore + " Se sei un tutore clicca su 'accesso tutori/genitori'";
        } else {
          errore = "Qualcosa è andato storto!";
        }
        msg_errore.innerHTML=errore;
        if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
        } else {
          div_errore.classList.add("visibilita");
        }
      })
}
</script>