<?php
  include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');
  $settings = AssoFacileRules::get_instance();
  $accept = $settings->get_attachement_types_for();
  include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');
  global $post;
  $link = get_permalink($post->ID, false);
  $rules = AssoFacileRules::get_instance();
?>
<div class="tab-profile">
  <input type="hidden" name="retrievedToken" id="retrievedToken"
    value="<?php echo $_COOKIE['assofacile_api_token']; ?>">
  <input type="hidden" name="idasso" id="idasso"
    value="<?php echo get_option('assofacile_assoc_id'); ?>">
  <h3 class="text-center">Comunicazioni</h3>
  <div id="threads"></div>
  <div class="d-flex flex-row-reverse nascosto" style="padding-right: 10px; margin-top: 10px;" id="newThread">
    <button class="btn btn-primary btn-sm" id="newThreadButton"
       title="Crea nuova comunicazione">
      <i class="fas fa-plus"></i> Crea nuova comunicazione
    </button>
    <button class="btn btn-primary btn-sm" style="margin-right: 4px;" id="reloadButton"
       title="Ricarica per vedere nuovi messaggi">
      <i class="fas fa-undo"></i>Ricarica per vedere nuovi messaggi
    </button>
  </div>
  <div class="">
    <div class="progress" id="waitFor" style="display: none;">
      <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%;">
      <span>Loading...</span>
      </div>
    </div>
    <div class="form-group nascosto" id="div_errore">
      <small class="text-danger" id="msg_errore"></small>
    </div>
    <div class="form-group nascosto" id="div_successo">
      <small class="text-success" id="msg_successo"></small>
    </div>
    <div id="cardsAndDocs" style="display: none;">
    </div>
  </div>
  <div class="mesgs">
    <div class="msg_history" id="thread">
    </div>
    <form class="form-group" id="sendForm">
      <div id="form-fields" class="form-group"></div>
      <button class="btn btn-primary align-right">Invia</button>
    </form>
  </div>
  <div class="incoming_msg" id="incoming_msg_template" style="display: none;">
    <div class="incoming_msg_img">
      <img src="https://ptetutorials.com/images/user-profile.png" name="senderPhoto" alt="senderPhoto">
    </div>
    <div class="received_msg">
      <div class="received_withd_msg">
        <p name="message">inserire qui un messaggio</p>
        <span class="time_date">
          <span name="dateTimeTime">12:44</span>
          <span> | </span>
          <span name="dateTimeDate">9 Giugno, 2018</span>
        </span>
        <div class="attachments d-flex flex-row flex-wrap align-items-center" name="attachments"></div>
      </div>
    </div>
  </div>
  <div class="outgoing_msg" id="outgoing_msg_template" style="display: none;">
    <div class="sent_msg">
      <p name="message">Risposta al messaggio inviato</p>
      <span class="time_date">
        <span name="dateTimeTime">12:44</span>
        <span> | </span>
        <span name="dateTimeDate">9 Giugno, 2018</span>
      </span>
      <div class="attachments d-flex flex-row flex-wrap align-items-center" name="attachments"></div>
    </div>
  </div>
  <a id="downloadLink" style="display: none;" target="_blank" download onclick="download_file()"></a>
</div>

<script>
document.addEventListener("DOMContentLoaded", function() {
    let div_errore = document.getElementById("div_errore");
    let div_successo = document.getElementById("div_successo");
    let msg_errore = document.getElementById("msg_errore");
    let msg_successo = document.getElementById("msg_successo");
    let reloadButton = document.getElementById("reloadButton");
    let campi_form = document.getElementById("form-fields");
    let btn_nuova_com = document.getElementById("newThreadButton");
    let div_nuova_com = document.getElementById("newThread");
    let div_msg_pres = document.getElementById("thread");
    /**
     * ricarica page per nuovi messaggi
     */
    reloadButton.addEventListener('click', () => {
      window.location.reload();
    });
    /**
     * messaggio aperto
     */
    let currentThread = null;
    let valore_token=document.getElementById("retrievedToken").value;
    let idassoValue = document.getElementById("idasso").value;
    const formData = new FormData();
    const now = new Date();
    const date = now.getUTCDate();
    const month = now.getUTCMonth() + 1;
    const token = toFixed((month / 17) * date, 11);
    const token2 = toFixed((idassoValue / date) * 13.7, 11);
    formData.append('token_lgn', valore_token);
    formData.append('idasso', idassoValue);
    formData.append('token', token);
    formData.append('token2', token2);
    function fetchLocal(url, data) {
      const newFormData = new FormData();
      for (const e of formData.entries()) {
        newFormData.append(e[0], e[1]);
      }
      for (const e of data.entries()) {
        newFormData.append(e[0], e[1]);
      }
      return fetch(url, {
        method: 'post',
        mode: 'cors',
        body: newFormData
      });
    }
    let contenitore = document.getElementById("cardsAndDocs");
    contenitore.style.display = 'none';
    let waitFor = document.getElementById("waitFor");
    waitFor.style.display = 'block';
    const sendForm = document.getElementById("sendForm");
    sendForm.addEventListener('submit', sendMessage);
    const fd = new FormData();
    fd.append('ordinamento', 'r');
    let array_type = [];
    let array_required = [];
    let array_name = [];
    let array_id = [];
    let array_placeholder = [];
    fetchLocal('<?php echo $rules->get_api_endpoints_for("msgs-list") ?>', fd).then((res) => {
      if (res.status != 200) throw 0;
      return res.text();
    }).then((res) => {
      let data;
      try {
        data = JSON.parse(res);
      } catch (err) {
        data = res.split('|');
        if (data[0] == 'errore') {
          throw data[1];
        } else {
          throw "Qualcosa è andato storto!";
        }
      }
      return data[0];
    }).then((res) => {
      let scroll = false;
      if (res.campi_nuova_comunicazione) {
        for (const field of res.campi_nuova_comunicazione) {
            array_type.push(field.type);
            array_required.push(field.required);
            array_name.push(field.name);
            array_id.push(field.id);
            array_placeholder.push(field.placeholder);
          }
      }
      function resetFields() {
        if (res.campi_nuova_comunicazione) {
          currentThread = null;
          campi_form.innerHTML='';
            for (const field of res.campi_nuova_comunicazione) {           
            let div = document.createElement('div');
            div.classList.add("form-group");
            let input = document.createElement('input');
            input.classList.add("form-control");
            input.setAttribute('type', field.type);
            if (field.required == 'yes') {
              input.setAttribute('required', 'required');
            }
            input.setAttribute('name', field.name);
            input.setAttribute('id', field.id);
            input.setAttribute('placeholder', field.placeholder);
            div.append(input);
            campi_form.append(div);
          }
          if (scroll === true) {
            btn_nuova_com.scrollIntoView({
              behavior: 'smooth' 
            });
          } else {
            scroll = true;
          }
        }
      }
    let threads = [];
    let tot_comunic = document.getElementById("threads");
    tot_comunic.innerHTML='';
      for (const thread of res.comunicazioni) {
        threads.push({
          id: thread.idcomunicazione,
          date: thread.data,
          hour: thread.ora,
          subject: thread.oggetto,
          newMsgs: thread.nuovi_msg,
          lastMsgHour: thread.ora_ultimo_msg,
          sender: thread.mittente_ultimo_msg,
        });
      }
      for (const thread of threads) {
        let div_com = document.createElement('div');
        div_com.setAttribute('class','d-flex flex-row linked communication-row');
        let i_com = '';
        if(thread.newMsgs){
          i_com = document.createElement('i');
          i_com.setAttribute('class','fa-button badge');
          i_com.innerText=thread.newMsgs;
        }
        let span_com = document.createElement('span');
        span_com.setAttribute('class','flex-fill d-flex flex-column');
        span_com.setAttribute('style', 'padding-left: 12px;');
        let span_com2 = document.createElement('span');
        span_com2.setAttribute('style', 'margin-bottom: 2px;');
        span_com2.innerText=thread.sender;
        let span_com3 = document.createElement('span');
        span_com3.innerText=thread.subject;
        let span_com4 = document.createElement('span');
        span_com4.setAttribute('class','text-muted');
        span_com4.innerText=thread.lastMsgHour + ' | ' + (new Date(thread.date)).toLocaleDateString();
        span_com.append(span_com2);
        span_com.append(span_com3);
        if(thread.newMsgs){
          div_com.append(i_com);
        }
        div_com.append(span_com);
        div_com.append(span_com4);
        div_com.addEventListener('click', () => {
          loadThread(thread.id);
        });
        tot_comunic.append(div_com);
      }
      resetFields();
      let newThreadButton = document.getElementById("newThreadButton");
      newThreadButton.addEventListener('click', () => {
        resetFields();
        });
      if (div_nuova_com.classList.contains("nascosto")) {
          div_nuova_com.classList.remove("nascosto");
          div_nuova_com.classList.add("visibilita");
      }
    }).catch(error => {
      console.log(error);
      let errore = '';
      if (
        error == 'Token di login scaduto' ||
        error == 'Token di login inesistente'
      ) {
        window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=profile'; ?>";
        return;
      }
      errore = error.error;
      msg_errore.innerHTML=errore;
      if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
      }
    }).finally(() => {
      waitFor.style.display = 'none';
      contenitore.style.display='block';
    });
    /**
     * Invia messaggio
     */
    function sendMessage(event) {
      event.preventDefault();
      const form = document.getElementById("sendForm");
      const formData = new FormData(form);
      /**
       * invio ad un messaggio esistente 
       */
      if (currentThread) {
        formData.append('idcomunicazione', currentThread);
      }
      fetchLocal('<?php echo $rules->get_api_endpoints_for("new-msg") ?>', formData).then((res) => {
        if (res.status != 200) throw 0;
        return res.text();
      }).then((res) => {
        const data = res.split('|');
        if (data[0] == 'errore') {
          throw data[1];
        } else {
          return data[1];
        }
      }).then((res) => {
        if (currentThread) {
          loadThread(currentThread);
        } else {
          window.location.reload();
        }
      }).catch(error => {
        console.log(error);
        let errore = '';
        if (
          error == 'Token di login scaduto' ||
          error == 'Token di login inesistente'
        ) {
          window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=profile'; ?>";
          return;
        }
        errore = error.error;
        msg_errore.innerHTML=errore;
        if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
        }
      }).finally(() => {
        waitFor.style.display = 'none';
        contenitore.style.display='block';
      });
    }
    /**
     * ricarica una comunicazione
     */
    function loadThread(threadId) {
      const formData = new FormData();
      formData.append('idcomunicazione', threadId);
      fetchLocal('<?php echo $rules->get_api_endpoints_for("thread-msgs") ?>', formData).then((res) => {
        if (res.status != 200) throw 0;
        return res.text();
      }).then((res) => {
        let data;
        try {
          data = JSON.parse(res);
        } catch (err) {
          data = res.split('|');
          if (data[0] == 'errore') {
            throw data[1];
          } else {
            throw "Qualcosa è andato storto!";
          }
        }
        return data[0];
      }).then((res) => {
        if (res.campi_nuovo_messaggio) {
        for (const field of res.campi_nuovo_messaggio) {
            array_type.push(field.type);
            array_required.push(field.required);
            array_name.push(field.name);
            array_id.push(field.id);
            array_placeholder.push(field.placeholder);
          }
      }
        if (res.campi_nuovo_messaggio) {
          campi_form.innerHTML='';
          for (const field of res.campi_nuovo_messaggio) {
            let div = document.createElement('div');
            div.classList.add("form-group");
            let input = document.createElement('input');
            input.classList.add("form-control");
            input.setAttribute('type', field.type);
            if (field.required == 'yes') {
              input.setAttribute('required', 'required');
            }
            input.setAttribute('name', field.name);
            input.setAttribute('id', field.id);
            input.setAttribute('placeholder', field.placeholder);
            div.append(input);
            campi_form.append(div);
          }
        }
        let messages = [];
        for (const msg of res.messaggi) {
          const m = {
            id: msg.idmessaggio,
            date: msg.data,
            hour: msg.ora,
            unread: msg.non_letto == 'si' ? false : true,
            sender: msg.mittente,
            sent: msg.direttivo == 'no' ? true : false,
            text: msg.testo,
            attachments: []
          };
          messages.push(m);
          for (const attachment of msg.allegati) {
            m.attachments.push(attachment.nome_file);
          }
          /**
           * settaggio id comunicazione globale 
           */
          currentThread = threadId;
        }
        messages = messages.reverse();
        div_msg_pres.innerHTML='';
        for (const message of messages) {
          let div_msg = document.createElement('div');
          if (message.sent) {
            let div_msg_inviati = document.getElementById("outgoing_msg_template");
            div_msg.innerHTML=div_msg_inviati.innerHTML;
            let classe_div_msg_inv = div_msg_inviati.getAttribute('class');
            div_msg.setAttribute('class', classe_div_msg_inv);
            let name_msg = div_msg.querySelectorAll('[name="message"]');
            name_msg[0].innerText=message.text;
            let name_data = div_msg.querySelectorAll('[name="dateTimeDate"]');
            name_data[0].innerText=(new Date(message.date)).toLocaleDateString();
            let name_orario = div_msg.querySelectorAll('[name="dateTimeTime"]');
            name_orario[0].innerText=message.hour;
            let allegati = div_msg.querySelectorAll('[name="attachments"]');   
            for (const attachment of message.attachments) {
              let span_msg = document.createElement('span');
              span_msg.setAttribute('style', 'margin-right: 2px;');
              span_msg.setAttribute('class', 'linked');
              span_msg.innerHTML=`<i class="fas fa-paperclip fa-button"></i>${attachment}`;
              span_msg.addEventListener('click', (e) => {
                downloadAttachment(e.target, {
                name: attachment,
                messageId: message.id
                });
              });
              allegati[0].append(span_msg);
            }
            div_msg_pres.append(div_msg)
          } else {
            let div_msg_inviati = document.getElementById("incoming_msg_template");
            div_msg.innerHTML=div_msg_inviati.innerHTML;
            let classe_div_msg_inv = div_msg_inviati.getAttribute('class');
            div_msg.setAttribute('class', classe_div_msg_inv);
           let name_msg = div_msg.querySelectorAll('[name="message"]');
            name_msg[0].innerText=message.text;
            let name_data = div_msg.querySelectorAll('[name="dateTimeDate"]');
            name_data[0].innerText=message.date;
            let name_orario = div_msg.querySelectorAll('[name="dateTimeTime"]');
            name_orario[0].innerText=message.hour;
            let allegati = div_msg.querySelectorAll('[name="attachments"]');
            for (const attachment of message.attachments) {
              let span_msg = document.createElement('span');
              span_msg.setAttribute('style', 'margin-right: 2px;');
              span_msg.setAttribute('class', 'linked');
              span_msg.innerHTML=`<i class="fas fa-paperclip fa-button"></i>${attachment}`;
              span_msg.addEventListener('click', (e) => {
                downloadAttachment(e.target, {
                name: attachment,
                messageId: message.id
                });
              });
              allegati[0].append(span_msg);
            }
            div_msg_pres.append(div_msg)
          }
        }
      }).catch(error => {
        console.log(error);
        let errore = '';
        if (
          error == 'Token di login scaduto' ||
          error == 'Token di login inesistente'
        ) {
          window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=massaging'; ?>";
          return;
        }
        errore = error;
        msg_errore.innerHTML=errore;
        if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
        }
      }).finally(() => {
        waitFor.style.display = 'none';
        contenitore.style.display='block';
      });
    }
    /**
     * download di un allegato
     */
    function downloadAttachment(element, info) {
      jElement = element;
      let originalHtml = jElement.innerHTML;
      let td = document.createElement('td');
      td.setAttribute('colspan', element.children.length);
      let div_p = document.createElement('div');
      div_p.setAttribute('class', 'progress');
      let div_p2 = document.createElement('div');
      div_p2.setAttribute('class', 'progress-bar progress-bar-success progress-bar-striped');
      div_p2.setAttribute('role', 'progressbar');
      div_p2.setAttribute('aria-valuenow', '40');
      div_p2.setAttribute('aria-valuemin', '0');
      div_p2.setAttribute('aria-valuemax', '100');
      div_p2.setAttribute('style', 'width: 100%; text-align: center;');
      let span_p = document.createElement('span');
      span_p.innerText='Downloading...';
      let span_p2 = document.createElement('span');
      span_p2.setAttribute('id', 'downloadProgress');
      span_p2.innerText='0';
      let span_p3 = document.createElement('span');
      span_p3.innerText='%';
      span_p2.append(span_p3);
      span_p.append(span_p2);
      div_p2.append(span_p);
      div_p.append(div_p2);
      td.append(div_p);
        td.addEventListener('click', (e) => {
          e.stopPropagation()
        });
      jElement.append(td);
      let progressElement = document.getElementById("downloadProgress");
      const formData1 = new FormData();
      for (const e of formData.entries()) { formData1.append(e[0], e[1]); };
      formData1.append('idmessaggio', info.messageId);
      formData1.append('allegato', info.name);

      fetchProgress('<?php echo $rules->get_api_endpoints_for("msg-attachment") ?>', {
        method: 'post',
        body: formData1,
        mode: 'cors',
      }, 'json', (progress) => {
        progressElement.innerText=progress.percentage;
      }).then((res) => {
        return res[0].file[0];
      }).then(async (res) => {
        const data = await base64ToBufferAsync(res.data);
        const file = new File([data], res.filename, {
          type: res["content-type"]
        });
        const url = URL.createObjectURL(file);
        let downloadLink=  document.getElementById("downloadLink");
        downloadLink.setAttribute('href', url);
        downloadLink.click();
        jElement.innerHTML=originalHtml;
      });
    }
  });
</script>
