<?php
include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');
global $post;
$link = get_permalink($post->ID, false);
$rules = AssoFacileRules::get_instance();
if (isset($_GET["tkn_tut"]) &&  $_GET["tkn_tut"] != "") {
  $tkn_tut = $_GET["tkn_tut"];
} else {
  $tkn_tut = $_COOKIE['assofacile_api_token'];
}

?>
<div class="tab-profile">
  <input type="hidden" name="retrievedToken" id="retrievedToken" value="<?php echo $tkn_tut; ?>">
  <input type="hidden" name="retrievedToken2" id="retrievedToken2" value="<?php echo $_COOKIE['assofacile_api_token2']; ?>">
  <input type="hidden" name="tokenLgn" id="tokenLgn" value="<?php echo $_COOKIE['token_lgn']; ?>">
  <input type="hidden" name="idasso" id="idasso" value="<?php echo get_option('assofacile_assoc_id'); ?>">
  <input type="file" name="profilePictureSelect" id="profilePictureSelect" style="display: none;" accept="image/png,image/jpg,image/jpeg">
  <h3 class="text-center">Il tuo Profilo</h3>
  <div class="">
    <div class="progress" id="waitFor" style="display: none;">
      <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%;">
        <span>Loading...</span>
      </div>
    </div>
    <div class="form-group nascosto" id="div_errore">
      <small class="text-danger" id="msg_errore"></small>
    </div>
    <div class="form-group nascosto" id="div_successo">
      <small class="text-success" id="msg_successo"></small>
    </div>
    <div id="profile" style="display: none;">
    </div>
  </div>
</div>
<script>
  let div_errore = document.getElementById("div_errore");
  let div_successo = document.getElementById("div_successo");
  let msg_errore = document.getElementById("msg_errore");
  let msg_successo = document.getElementById("msg_successo");
  let valore_token=document.getElementById("retrievedToken").value;
  let accesso_tutore='';
  let array_valori_token = valore_token.split('-');
  let profilo = document.getElementById("profile");
  let idassoValue = document.getElementById("idasso").value;
  let waitFor = document.getElementById("waitFor");
  waitFor.style.display = 'block';
  if (array_valori_token.length==3) {
      accesso_tutore='si';
    }else if(array_valori_token.length==2){
      accesso_tutore='no';
  }
  // cambio foto profilo
  let profilePictureUrl = null;
    if (accesso_tutore=='no') {
    let profilePictureSelect = document.querySelectorAll("input#profilePictureSelect");
    //profilePictureSelect
    profilePictureSelect[0].addEventListener("change", (event) => {
      event = event.target;
      if (event.files && event.files.length) {
      const file = event.files[0];
      const url = URL.createObjectURL(file);
      let profile_profile_picture = document.getElementById("profile_profile_picture");
      profile_profile_picture.setAttribute('src',url);
      let profilePictureActions = document.getElementById("profilePictureActions");
      profilePictureActions.setAttribute('style','display: block;');
    }else {
      profile_profile_picture.setAttribute('src',profilePictureUrl);
    }
    });
  }
  document.addEventListener("DOMContentLoaded", function(){
    const formData = new FormData();
    const now = new Date();
    const date = now.getUTCDate();
    const month = now.getUTCMonth() + 1;
    const token = toFixed((month / 17) * date, 11);
    const token2 = toFixed(((idassoValue / date) * 13.7), 11);
    formData.append('token_lgn', valore_token);
    formData.append('idasso', idassoValue);
    formData.append('token', token);
    formData.append('token2', token2);
    fetch('<?php echo $rules->get_api_endpoints_for("profile") ?>', {
      method: 'post',
      mode: 'cors',
      body: formData
    }).then((res) => {
      if (res.status != 200) throw 0;
      return res.text();
    }).then((res) => {
      let parts = res.split('|');
      if (parts[0] == 'errore') {
        throw {
          thrown: true,
          error: parts[1]
        }
      }
      return JSON.parse(res);
    }).then((res) => {
      return res[0];
    }).then(async (res) => {
      if (res.sesso == 'f') {
        res.sesso = "<?php _e('Female', 'assofacile'); ?>";
      } else if (res.sesso == 'm') {
        res.sesso = "<?php _e('Male', 'assofacile'); ?>";
      }
      let url;
        if (res.img && res.img.length) {
          const img = res.img[0];
          const data = await base64ToBufferAsync(img.data);
          const file = new File([data], img.filename, {
            type: res["content-type"]
          });
          url = URL.createObjectURL(file);
          profilePictureURL = url;
        }
        if (res.tessera && res.tessera.length) {
          const tessera = res.tessera[0];
          const pdfData = await base64ToBufferAsync(tessera.data);
          const pdf = new File([pdfData], tessera.filename, {
            type: tessera["content-type"]
          });
          tessera_url = URL.createObjectURL(pdf);
        }
      let childs = [];    
      for (const data of res.dati) {
        if (!(data.valore.startsWith('candidato'))) {
          nuovo_div_res = document.createElement("div");
          nuovo_div_res.classList.add("form-group");
          nuovo_h5 = document.createElement("h5");
          nuovo_h5.innerHTML=data.etichetta;
          nuovo_p_res = document.createElement("p");
          nuovo_p_res.innerHTML=data.valore;
          nuovo_div_res.appendChild(nuovo_h5);
          nuovo_div_res.appendChild(nuovo_p_res);
          childs.push(nuovo_div_res);
        }
      }
      if (typeof tessera_url !== 'undefined') {
        tessera_obj = document.createElement('a');
        tessera_obj.setAttribute('style','margin-top: 10px; font-weight: bold;');
        tessera_obj.setAttribute('href',tessera_url);
        tessera_obj.setAttribute('target','_blank');
        let testo_t = "Scarica tessera";
        tessera_obj.append(testo_t);
      } else {
        tessera_obj = document.createElement('a');
      }
      if (accesso_tutore=='no') {
        profilo.innerHTML='';
        let nuovo_div = document.createElement('div');
        nuovo_div.setAttribute('class','d-flex flex-column align-items-center');
        let nuovo_div_1 = document.createElement('div');
        nuovo_div_1.setAttribute('class','profile_profile');
        nuovo_div_1.setAttribute('style','position: relative;');
        let nuova_img = document.createElement('img');
        nuova_img.setAttribute('src',url);
        nuova_img.setAttribute('class','profile_profile_picture');
        nuova_img.setAttribute('id','profile_profile_picture');
        let nuovo_tag_i = document.createElement('i');
        nuovo_tag_i.setAttribute('id','editProfilePictureButton');
        nuovo_tag_i.setAttribute('class','fa-button fas fa-pen');
        nuovo_tag_i.setAttribute('style','position: absolute; top: 2px; right: 2px; color: #0d6efd; z-index: 100; display: none;');       
        nuova_img.addEventListener('mouseover', () => {
         nuovo_tag_i.style.display = 'block';
        });
        nuova_img.addEventListener('mouseout', () => {
          nuovo_tag_i.style.display = 'none';
        });
        nuova_img.addEventListener('click', () => {
          profilePictureSelect.click();
        });
        let nuovo_div_2 = document.createElement('div');
        nuovo_div_2.setAttribute('id','profilePictureActions');
        nuovo_div_2.setAttribute('class','d-flex flex-row align-items-center');
        nuovo_div_2.setAttribute('style','display: none;');
        let nuovo_button = document.createElement('button');
        nuovo_button.setAttribute('id','profilePictureSave');
        nuovo_button.setAttribute('class','fa-button btn btn-sm btn-primary');
        nuovo_button.setAttribute('style','margin-right: 2px');
        nuovo_button.addEventListener('click', () => {
          const target = profilePictureSelect;
          if (!target) {
            return;
          }
          if (target.files && target.files.length) {
            updateProfilePicture();
          }
        });
        let nuovo_tag_i_2 = document.createElement('i');
        nuovo_tag_i_2.setAttribute('class','fa-button fas fa-save');
        let nuovo_button_2 = document.createElement('button');
        nuovo_button_2.setAttribute('id','profilePictureCancel');
        nuovo_button_2.setAttribute('class','fa-button btn btn-sm btn-danger');
        nuovo_button_2.addEventListener('click', () => {
          nuovo_div_2.style.display = 'none';
        });
        let nuovo_tag_i_3 = document.createElement('i');
        nuovo_tag_i_3.setAttribute('class','fa-button fas fa-times');
        nuovo_button.append(nuovo_tag_i_2);
        nuovo_button_2.append(nuovo_tag_i_3);
        nuovo_div_2.append(nuovo_button, nuovo_button_2);
        nuovo_div_1.append(nuova_img, nuovo_tag_i, nuovo_div_2);
        let nuovo_p = document.createElement('p');
        nuovo_p.setAttribute('style','margin-top: 20px; font-weight: bold;');
        nuovo_p.setAttribute('id','nome_profilo_utente');
        let testo = res.nome;
        nuovo_p.append(testo);     
        nuovo_div.append(nuovo_div_1, nuovo_p);
        nuovo_div.append(tessera_obj);
        profilo.appendChild(nuovo_div);
        for (let i = 0; i < childs.length; i++) {
          let singolo_c = childs[i];
          document.getElementById("profile").appendChild(singolo_c);
        }
      } else{
        profilo.innerHTML='';
        let nuovo_div = document.createElement('div');
        nuovo_div.setAttribute('class','d-flex flex-column align-items-center');
        let nuovo_p = document.createElement('p');
        nuovo_p.setAttribute('style','margin-top: 20px; font-weight: bold;');
        nuovo_p.setAttribute('id','nome_profilo_utente');
        let testo = res.nome;
        nuovo_p.append(testo);  
        nuovo_div.appendChild(nuovo_p);
        profilo.appendChild(nuovo_div);
        for (let i = 0; i < childs.length; i++) {
          let singolo_c = childs[i];
          document.getElementById("profile").appendChild(singolo_c);
        }
      }
      profilo.style.display = 'block';
      fin("profile");
    }).catch(error => {
      console.log(error);
      let errore = '';
      if (!error.thrown) {
        errore = "Qualcosa è andato storto!";
      } else {
        if (
          error.error == 'Token di login scaduto' ||
          error.error == 'Token di login inesistente' ||
          token_lgn == ""
        ) {
          window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=profile'; ?>";
          return;
        }
        errore = error.error;
      }
      msg_errore.innerHTML=errore;
      if (div_errore.classList.contains("nascosto")) {
        div_errore.classList.remove("nascosto");
        div_errore.classList.add("visibilita")
      }
    }).finally(() => {
      waitFor.style.display = 'none';
    });
    /* AGGIORNA FOTO PROFILO */
    function updateProfilePicture() {
      fin("waitFor");
      profilePictureActions.setAttribute('style','display: none;');
      const formData1 = new FormData();
      for (const e of formData.entries()) {
        formData1.append(e[0], e[1]);
      }      
      formData1.append('imagefile', profilePictureSelect.files[0]);
      fetch('<?php echo $rules->get_api_endpoints_for("updateProfilePicture") ?>', {
        method: 'post',
        mode: 'cors',
        body: formData1
      }).then((res) => {
        if (res.status != 200) throw 0;
        return res.text();
      }).then((res) => {
        let parts = res.split('|');
        if (parts[0] == 'errore') {
          throw {
            thrown: true,
            error: parts[1]
          }
        }
        return JSON.parse(res);
      }).then((res) => {
        return res[0];
      }).then(async (res) => {
        let url;
        if (div_successo.classList.contains("nascosto")) {
          div_successo.classList.remove("nascosto");
          div_successo.classList.add("visibilita");
          msg_successo.innerText = res.risultato;
        }
        //msg di successo scompare cliccando su un punto qualsiasi
        window.onclick = function(event) {
          if (event.target != div_successo) {
            if (div_successo.classList.contains("visibilita")) {
              div_successo.classList.remove("visibilita");
              div_successo.classList.add("nascosto");
            }
          }
        }
        if (res.img && res.img.length) {
          const img = res.img[0];
          const data = await base64ToBufferAsync(img.data);
          const file = new File([data], img.filename, {
            type: res["content-type"]
          });

          url = URL.createObjectURL(file);
          profilePictureURL = url;
        }
      }).catch(error => {
        console.log(error);
        let errore = '';
        if (!error.thrown) {
          errore = "Qualcosa è andato storto!";
        } else {
          if (
            errore.error == 'Token di login scaduto' ||
            errore.error == 'Token di login inesistente'
          ) {
            window.location.href = "<?php echo $link; ?>?redirect_url=<?php echo $link . '?tab=profile'; ?>";
            return;
          }
          errore = error.error;
        }
        msg_errore.innerHTML=errore;
        if (div_errore.classList.contains("nascosto")) {
          div_errore.classList.remove("nascosto");
          div_errore.classList.add("visibilita");
        }
      }).finally(() => {
        waitFor.style.display = 'none';
      });
    }
    function fin(id) {
      var i = 0;
      var el = document.getElementById(id);
      fadeIn(el, i);
    }
    function fadeIn(el, i) {
      i = i + 0.01;
      seto(el, i);
      if (i < 1) {
        setTimeout(function() {
          fadeIn(el, i);
        }, 10);
      }
    }
    function seto(el, i) {
      el.style.opacity = i;
    }
  });
</script>