<?php
include_once(plugin_dir_path(__DIR__) . 'class.assofacile-rules.php');

global $post;
$link = get_permalink($post->ID, false);
$rules = AssoFacileRules::get_instance();
?>

<div class='m-auto'>
  <div class="card">
    <div class="d-flex flex-column justify-content-center card-title align-items-center">
      <h2><?php _e("AssoFacile", "assofacile") ?></h2>
      <h5 class="ml-1"><?php _e("Create Account", "assofacile") ?></h5>
    </div>

    <div class="card-body" class="padding: 10px 0px;">
      <div class="progress" id="waitFor" style="display: none;">
        <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%;">
          <span><?php _e("Loading", "assofacile"); ?>...</span>
        </div>
      </div>

      <div style="padding: 0px 5px; display: none;" id="responseErrorContainer">
        <p><small class="text-info">
            <?php _e("Every field with", "assofacile") ?>
            <span class="text-danger">*</span>
            <?php _e("is required", "assofacile") ?>!
          </small></p>

        <small id="responseErrorMessage" style="display: none;" class="text-danger">
        </small>

        <small id="responseErrorGeneral" style="display: none;">
          <?php _e("Something went wrong with your request", "assofacile"); ?>. </span>
          <span><?php _e("Please check all inputs and try again", "assofacile"); ?>.</span>
        </small>

        <small id="responseErrorNoRegistration" style="display: none;">
          <?php _e("Registration is disabled by adminstration", "assofacile"); ?>!
        </small>

        <hr>
      </div>

      <form class="form" id="form">
        <div class="form-group">
          <input type="hidden" value="<?php echo get_option('assofacile_assoc_id'); ?>" id="idasso" name="idasso">
        </div>
      </form>

      <div class="d-flex flex-row">
        <button class="btn btn-primary mr-2" id="formSubmitBtn"><?php _e("Continue", "assofacile"); ?></button>
        <a href="<?php echo $link; ?>?tab=login"><?php _e('Login instead', 'assofacile'); ?></a>
      </div>

      <div class="panel panel-default" id="success" style="display: none;">
        <div class="panel-heading">
          <div class="panel-title"><?php _e("Registration Saved", "assofacile"); ?>!</div>
        </div>

        <div class="panel-body">
          <span><?php _e("Your registration has been saved successfully", "assofacile"); ?>! </span>
          <span><?php _e("You will be able to login, once it is approved by adminstrator", "assofacile"); ?>.</span>
        </div>
      </div>
    </div>
  </div>
</div>

<script>
  jQuery(document).ready(($) => {
    const form = $("#form");
    const formSubmitBtn = $("#formSubmitBtn");
    const waitFor = $('#waitFor');
    const responseErrorContainer = $('#responseErrorContainer');
    const responseErrorGeneral = $('#responseErrorGeneral');
    const responseErrorMessage = $('#responseErrorMessage');
    const responseErrorNoRegistration = $('#responseErrorNoRegistration');
    const success = $("#success");
    const formData = new FormData();
    let files = []; // downloaded files
    cities = []; // downloaded cities at stage 1
    states = []; // downloaded cities at stage 1
    let step = 0;
    final = false;

    async function submitForm() {
      // hide all errors before submit
      const formDataNew = new FormData(form[0]);
      responseErrorMessage.text('').hide();
      responseErrorContainer.hide();
      responseErrorGeneral.hide();
      responseErrorNoRegistration.hide();
      formSubmitBtn.attr('disabled', true);

      // hide form, show loading
      form.hide();
      waitFor.show();

      const now = new Date();
      const month = now.getUTCMonth() + 1;
      const date = now.getUTCDate();
      //const idassoValue = Number(formData.get('idasso')) || Number(formDataNew.get('idasso'));
      let idassoValue = document.getElementById("idasso").value;
     // console.log(formData.get('idasso'));
      //console.log(formDataNew.get('idasso'));
      console.log(idassoValue);
      const token = toFixed((month / 17) * date, 11);
      const token2 = toFixed((idassoValue / date) * 13.7, 11);
      if (!formData.get('token')){
        formData.append('token', token);
      } 
      if(!formData.get('token2')) 
      {
        formData.append('token2', token2);
      }
      console.log(formData.get('token'));
      console.log(!formData.get('token'));
      for (const e of formDataNew.entries()) {
        formData.append(e[0], e[1]);
      }

      if (final) {
        sendForm(formData);
        return;
      }

      return fetch('<?php echo $rules->get_api_endpoints_for("register-form") ?>', {
        body: formData,
        method: 'post',
        mode: 'cors',
        headers: {
          'accept': 'application/json'
        }
      }).then(res => {
        if (res.status != 200) throw res;
        return res.text();
      }).then(res => {
        return res.replace(/\\'/ig, "'");
      }).then(res => {
        return JSON.parse(res);
      }).then((res) => {
        waitFor.hide();
        form.html('');
        // add new controls to form
        files = [];
        if (res[30]) {
          if (res[30].placeholder == "Tipo di documento di identit�") {
            res[30].placeholder = "Tipo di documento di identita'"
          }
        }
        if (res[31]) {
          if (res[31].placeholder == "Numero documento di identit�") {
            res[31].placeholder = "Numero documento di identita'"
          }
        }

        for (const r of res) {
          if (r.type == 'fine_campi') {
            final = true;
            continue;
          }

          if (r.options) {
            if (r.options[0].text == "s�") {
              r.options[0].text = "si";
            }
          }

          if (step == 0) {
            if (r.name == 'comuni') {
              cities = r.values || [];
              continue;
            } else if (r.name == 'regioni') {
              states = r.values || [];
              continue;
            }
          }

          const control = new ControlFactory(r);
          const e = control.getElement();

          form.append(e);
        }

        if (step != 0) {
          const selects = $("select");

          for (const select of selects) {
            if (select.name?.match(/^idregione/)) {
              const statesElement = $(select).html('');
              const name = select.name.replace('regione', 'comune');
              const citiesElement = $(`select[name="${name}"]`);

              for (const state of states) {
                statesElement.append(
                  $(document.createElement('option'))
                  .text(state.value)
                  .val(state.id)
                  .attr('data-id', state.id)
                );
              }

              function refill() {
                waitFor.show();
                form.hide();
                const selectedState = statesElement.find(':selected');
                const stateId = selectedState?.attr('data-id');

                if (stateId) {
                  citiesElement.html('');
                  const filteredCities = cities.filter(i => i.idregione == stateId);

                  for (const city of filteredCities) {
                    citiesElement.append(
                      $(document.createElement('option'))
                      .text(city.value)
                      .val(city.id)
                    );
                  }

                }

                waitFor.hide();
                form.show();
              }

              statesElement.change(refill);
              refill();
            }
          }
        }

        form.fadeIn();
        step++;
      }).catch((err) => {
        if (err == "Registrations not allowed")
          responseErrorNoRegistration.show();
        else
          responseErrorGeneral.show();

        responseErrorContainer.show();

        waitFor.hide();
        form.show();
        throw err;
      }).finally(() => {
        formSubmitBtn.attr('disabled', false);
      });
    }

    // submit form using external button
    formSubmitBtn.click(() => {
      form.submit();
    });

    // attach handler to form
    form.submit((event) => {
      submitForm();
      event.preventDefault();
    });

    // trigger form submission for first time
    form.submit();

    function sendForm(formData) {
      responseErrorMessage.text('').hide();
      responseErrorContainer.hide();
      responseErrorGeneral.hide();
      responseErrorNoRegistration.hide();
      formSubmitBtn.attr('disabled', true);

      fetch('<?php echo $rules->get_api_endpoints_for("register") ?>', {
        body: formData,
        method: 'post',
        mode: 'cors',
        headers: {
          'accept': 'application/json'
        }
      }).then(res => {
        if (res.status != 200) throw res;
        return res.text();
      }).then(res => {
        const parts = res.split('|');
        if (parts[0] != 'ok') {
          throw parts[1];
        } else {
          return parts[1];
        }
      }).then(res => {
        form.html(`<b>${res}</b>`);
      }).catch(err => {
        if (err == "Registrations not allowed") {
          responseErrorNoRegistration.show();
        } else if (!err) {
          responseErrorGeneral.show();
        } else {
          responseErrorMessage.text(err).show();
        }

        responseErrorContainer.show();

        $('html, body').animate({
          scrollTop: responseErrorContainer.offset().top
        }, 1000);

        waitFor.hide();
      }).finally(() => {
        form.fadeIn();
        formSubmitBtn.attr('disabled', false);
      });
    }
  });
</script>